{
  Name    :   Login.pas

  Purpose :   Handles user login to the Delphi Bank application.

  Usage   :   This source code is supplied as example code with Delphi Informant
               magazine.
              The author makes no guarantee for its correctness or fitness
               for any purpose and cannot be held responsible for any loss
               or damage that may occur through its use or misuse.
              You may copy, modify or use any part of this source code
               provided the author is credited for his work.

  Author  :   Paul M. Fairhurst, September 1998. paul@c-s-c.demon.co.uk
              (Based on code kindly donated by Mark Smith)
}
unit Login;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons,
  CustomerInfo;

type
  TLoginDlg = class(TForm)
    Label1: TLabel;
    Password: TEdit;
    OKBtn: TButton;
    CancelBtn: TButton;
    Label2: TLabel;
    LogonIDEdit: TEdit;
    procedure OKBtnClick(Sender: TObject);
  private
    FCust: TCustomer;

  private
    { Private declarations }
  public
    { Public declarations }
    class procedure Login (Cust :TCustomer);
  end;

var
  LoginDlg: TLoginDlg;

implementation


uses
    Dialogs,
    DelphiBankServer3_TLB,
    ClientUtils;

{$R *.DFM}

{ TLoginDlg }

class procedure TLoginDlg.Login (Cust :TCustomer);
var
  LoginDlg: TLoginDlg;
begin
  LoginDlg := TLoginDlg.Create(Application);
  try
    LoginDlg.FCust := Cust;
    LoginDlg.ShowModal;
  finally
    LoginDlg.Free;
  end;
end;

procedure TLoginDlg.OKBtnClick(Sender: TObject);
var
  LogonID, UserName, UserPwd : Widestring;
  Notes, StrDebug : Widestring;
  CustID, ClientKey : integer;
begin
  LogonID := LogonIDEdit.Text;
  UserPwd := Password.Text;

  { Get customer details from MTS. }
  if ClientServices.Customers.Logon(LogonID, UserPwd, UserName, Notes,
                                    CustID, ClientKey, StrDebug) <> 0 then
    raise Exception.Create ('Login problem: ' + StrDebug)
  else begin
  { Fill TCustomer structure with info from server. }
    FCust.LogonID   := LogonID;
    FCust.UserName  := UserName;
    FCust.Password  := UserPwd;
    FCust.CustNotes := Notes;
    FCust.CustID    := CustID;
    ClientServices.ClientKey := ClientKey;
    FCust.Load;
    ModalResult := mrOK;
  end;
end;

end.

