{
  Name    :   Main.pas

  Purpose :   Main module for DelphiBankClient2

  Usage   :   This source code is supplied as example code with Delphi Informant
               magazine.
              The author makes no guarantee for its correctness or fitness
               for any purpose and cannot be held responsible for any loss
               or damage that may occur through its use or misuse.
              You may copy, modify or use any part of this source code
               provided the author is credited for his work.

  Author  :   Paul M. Fairhurst, September 1998. paul@c-s-c.demon.co.uk
              (Based on code kindly donated by Mark Smith)
}
unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActnList, Menus, StdActns,
  CustomerInfo,
  BankWinMessages;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    About: TAction;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Arrange: TWindowArrange;
    Cascade: TWindowCascade;
    MinimizeAll: TWindowMinimizeAll;
    TileHorizontally: TWindowTileHorizontal;
    Window1: TMenuItem;
    ArrangeAll1: TMenuItem;
    Cascade2: TMenuItem;
    Tile1: TMenuItem;
    Exit: TAction;
    Login: TAction;
    Login1: TMenuItem;
    procedure ExitExecute(Sender: TObject);
    procedure LoginExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  protected
    procedure BWMAccount (var Message : TMessage); message BWM_ACCOUNT;
    procedure BWMCust (var Message : TMessage); message BWM_CUST;
  public
    { Public declarations }
    Customers : TCustomerCollection;
  end;

var
  MainForm: TMainForm;

implementation

uses Login, AccountsListForm, ClientUtils;

{$R *.DFM}

procedure TMainForm.ExitExecute(Sender: TObject);
begin
  close;
end;

procedure TMainForm.LoginExecute(Sender: TObject);
var
  Cust : TCustomer;
begin
  Cust := TCustomer(Customers.Add);
  TLoginDlg.Login (Cust);
  if Cust.CustID <> 0 then
    TAccountsList.ShowAccounts (Cust)
  else
    Cust.Free;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Customers := TCustomerCollection.Create (TCustomer);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Customers.Free;
  ClientServices.ShutDown;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  LoginExecute (Sender);
end;

procedure TMainForm.BWMAccount(var Message: TMessage);
var
  i : integer;
begin
  for i := 0 to MDIChildCount-1 do
  begin
    PostMessage (MDIChildren[i].Handle, Message.Msg, Message.WParam, Message.LParam);
  end;
end;

procedure TMainForm.BWMCust(var Message: TMessage);
var
  i : integer;
begin
  for i := 0 to MDIChildCount-1 do
  begin
    PostMessage (MDIChildren[i].Handle, Message.Msg, Message.WParam, Message.LParam);
  end;

end;

end.
