unit FormReportClientMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TfrmReportClientMain = class(TForm)
    Panel1: TPanel;
    pnlOpenedReports: TPanel;
    Label1: TLabel;
    lstbxOpenedReports: TListBox;
    rdgrpReportType: TRadioGroup;
    btnOpenReport: TButton;
    btnPrintReport: TButton;
    btnCloseReport: TButton;
    Panel2: TPanel;
    btbtnClose: TBitBtn;
    rdgrpReportScope: TRadioGroup;
    btbtnDaysEnd: TBitBtn;
    procedure btnOpenReportClick(Sender: TObject);
    procedure btnCloseReportClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnPrintReportClick(Sender: TObject);
    procedure btbtnDaysEndClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmReportClientMain: TfrmReportClientMain;

implementation
uses ReportsServer1_TLB;

var
  ReportsServer : IReports;

{$R *.DFM}

procedure TfrmReportClientMain.btnOpenReportClick(Sender: TObject);
var ReportName : String;
begin
  ReportName := rdgrpReportType.Items[rdgrpReportType.ItemIndex] +
          ' ' + rdgrpReportScope.Items[rdgrpReportScope.ItemIndex];

  if ReportsServer.GetReport(ReportName) then
  begin
    lstbxOpenedReports.Items.Add(ReportName);
    btnCloseReport.Enabled := True;
  end
    else MessageDlg('That report is already opened.',mtError,[mbOK],0);
end;

procedure TfrmReportClientMain.btnCloseReportClick(Sender: TObject);
begin
  with lstbxOpenedReports do
  begin
    if ItemIndex = -1 then
      MessageDlg('No report is currently selected.',mtError,[mbOK],0)
    else begin
           ReportsServer.CloseReport(Items[ItemIndex]);
           Items.Delete(ItemIndex);
           if ReportsServer.getReportCount = 0 then
             btnCloseReport.Enabled := False;
         end;
  end; // with lstbxOpenedReports.
end;

procedure TfrmReportClientMain.FormCreate(Sender: TObject);
begin
  ReportsServer := TReportsCorbaFactory.CreateInstance('Reports1');
end;

procedure TfrmReportClientMain.btnPrintReportClick(Sender: TObject);
begin
  if ReportsServer.PrintReport(lstbxOpenedReports.Items[lstbxOpenedReports.ItemIndex]) then
    ShowMessage('Printing...');
end;

procedure TfrmReportClientMain.btbtnDaysEndClick(Sender: TObject);
begin
  if ReportsServer.DoDaysEndReports then
    MessageDlg('Days end reports complete.',mtInformation,[mbOK],0);
end;

end.
