unit Main;
                { Copyright  1998-99 by Igor Glukhov}
                     { Project name: ProHelpLight}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, Buttons, Menus, Registry, ShellApi,
  ProHelpLight, Tabnotbk;


type
  TMainForm = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    MainMenu: TMainMenu;
    HelpMenu: TMenuItem;
    Label3: TLabel;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    Block_Ident_CB: TComboBox;
    Label4: TLabel;
    Undo_Limit_CB: TComboBox;
    Label5: TLabel;
    Tab_Stops_CB: TComboBox;
    Label6: TLabel;
    Synt_Ext_CB: TComboBox;
    Label7: TLabel;
    Speed_Setting_CB: TComboBox;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    Bevel3: TBevel;
    GroupBox3: TGroupBox;
    Cancel_button: TButton;
    Apply_Button: TButton;
    Help_button: TButton;
    Ok_button: TButton;
    GroupBox4: TGroupBox;
    GroupBox2: TGroupBox;
    Shape2: TShape;
    Label2: TLabel;
    Image2: TImage;
    Label1: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Contents_MI: TMenuItem;
    IGSoftware_MI: TMenuItem;
    Register_MI: TMenuItem;
    About_MI: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    MainFrmF1Help_CB: TCheckBox;
    PopupWhatIsThis_CB: TCheckBox;
    MainFrmRButtonHelp_CB: TCheckBox;
    PopupWnd_CB: TCheckBox;
    Label15: TLabel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    DefaultSettings_CB: TCheckBox;
    DesignSpec_MI: TMenuItem;
    Memo1: TMemo;
    UseDefTopic_CB: TCheckBox;
    igProHelpLight1: TigProHelpLight;
    procedure FormCreate(Sender: TObject);
    procedure About_MIClick(Sender: TObject);
    procedure SetCBState(Enabled: Boolean);
    procedure SetDefaultSettings;
    procedure DefaultSettings_CBClick(Sender: TObject);
    procedure MainFrmF1Help_CBClick(Sender: TObject);
    procedure MainFrmRButtonHelp_CBClick(Sender: TObject);
    procedure PopupWhatIsThis_CBClick(Sender: TObject);
    procedure PopupWnd_CBClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure igProHelpLight1ControlHC(Control: TControl;
      RequestType: TRequestType; MousePos: TPoint;
      var HelpContext: THelpContext; var ShowHelp: Boolean);
    procedure UseDefTopic_CBClick(Sender: TObject);
    procedure DesignSpec_MIClick(Sender: TObject);
    procedure IGSoftware_MIClick(Sender: TObject);
    procedure Register_MIClick(Sender: TObject);
    procedure Contents_MIClick(Sender: TObject);
    procedure igProHelpLight1MainFormF1Help(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
var
Str: TFileStream;
implementation
{$R *.DFM}
procedure TMainForm.FormCreate(Sender: TObject);
begin
  Speed_Setting_CB.ItemIndex := 0;
  Application.HelpFile := ExtractFilePath(Application.ExeName) + '..\..\demohelpfiles\phldemo.hlp';
  SetDefaultSettings;
  SetCBState(False);
end;

procedure TMainForm.About_MIClick(Sender: TObject);
begin
 Application.MessageBox(PChar(igProHelpLight1.About),'About TigProHelpLight',0);
end;

procedure TMainForm.SetCBState(Enabled: Boolean);
begin
  MainFrmF1Help_CB.Enabled := Enabled;
  PopupWhatIsThis_CB.Enabled := Enabled;
  MainFrmRButtonHelp_CB.Enabled := Enabled;
  PopupWnd_CB.Enabled := Enabled;
  UseDefTopic_CB.Enabled := Enabled;
end;

procedure TMainForm.SetDefaultSettings;
begin
  igProHelpLight1.SetDefaultMode;
  MainFrmF1Help_CB.Checked := False;
  PopupWhatIsThis_CB.Checked := True;
  MainFrmRButtonHelp_CB.Checked := True;
  PopupWnd_CB.Checked := False;
  UseDefTopic_CB.Checked := True;
  igProHelpLight1.ContextWindow := '';
end;

procedure TMainForm.DefaultSettings_CBClick(Sender: TObject);
begin
  if TCheckBox(Sender).Checked then begin
    SetDefaultSettings;
    SetCBState(False);
  end
  else SetCBState(True);
end;

procedure TMainForm.MainFrmF1Help_CBClick(Sender: TObject);
begin
  with igProHelpLight1 do begin
    if TCheckBox(Sender).Checked then
      ControlFlags := ControlFlags + [cfMainFrmF1Help]
    else
      ControlFlags := ControlFlags - [cfMainFrmF1Help];
  end;
end;

procedure TMainForm.MainFrmRButtonHelp_CBClick(Sender: TObject);
begin
  with igProHelpLight1 do begin
    if TCheckBox(Sender).Checked then
      ControlFlags := ControlFlags + [cfMainFrmRButtonHelp]
    else
      ControlFlags := ControlFlags - [cfMainFrmRButtonHelp];
  end;
end;

procedure TMainForm.PopupWhatIsThis_CBClick(Sender: TObject);
begin
  with igProHelpLight1 do begin
    if TCheckBox(Sender).Checked then
      ControlFlags := ControlFlags + [cfPopupWhatIsThis]
    else
      ControlFlags := ControlFlags - [cfPopupWhatIsThis];
  end;
end;

procedure TMainForm.PopupWnd_CBClick(Sender: TObject);
begin
  with igProHelpLight1 do begin
    if TCheckBox(Sender).Checked then
      ContextWindow := 'popup'
    else
      ContextWindow := '';
  end;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
  MessageDlg('All speed buttons are placed on this form for demo purposes only!',mtWarning,[mbOk],0);
end;

procedure TMainForm.igProHelpLight1ControlHC(Control: TControl;
  RequestType: TRequestType; MousePos: TPoint;
  var HelpContext: THelpContext; var ShowHelp: Boolean);
begin
  if HelpContext = 0 then ShowHelp := false;
end;

procedure TMainForm.UseDefTopic_CBClick(Sender: TObject);
begin
   with igProHelpLight1 do begin
    if TCheckBox(Sender).Checked then
      ControlFlags := ControlFlags + [cfDefaultHelpTopic]
    else
      ControlFlags := ControlFlags - [cfDefaultHelpTopic];
  end;
end;

procedure TMainForm.DesignSpec_MIClick(Sender: TObject);
begin
  ShellExecute(Self.Handle,'open','http://www.microsoft.com/win32dev/uiguide/uigui344.htm',nil,nil,SW_SHOWNORMAL);
end;

procedure TMainForm.IGSoftware_MIClick(Sender: TObject);
begin
  ShellExecute(Self.Handle,'open','http://www.igweb.pair.com',nil,nil,SW_SHOWNORMAL);
end;

procedure TMainForm.Register_MIClick(Sender: TObject);
begin
  ShellExecute(Self.Handle,'open','http://www.igweb.pair.com/regpage.htm',nil,nil,SW_SHOWNORMAL);
end;

procedure TMainForm.Contents_MIClick(Sender: TObject);
begin
  WinHelp(Application.Handle,PChar(ExtractFilePath(Application.ExeName) + '..\..\Help\ProHelpLight.hlp'),HELP_FINDER,0);
end;

procedure TMainForm.igProHelpLight1MainFormF1Help(Sender: TObject);
begin
if not (cfMainFrmF1Help in igProHelpLight1.ControlFlags) then
   Contents_MIClick(Sender);
end;

end.
