unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, Grids, DBGrids, Db, DBTables;

type
  ECustomException = class(Exception);
  EInvalidCustNoException = class(ECustomException);
  EDuplicateCustomer = class(ECustomException);
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Table1CustNo: TFloatField;
    Table1Company: TStringField;
    Table1Addr1: TStringField;
    Table1Addr2: TStringField;
    Table1City: TStringField;
    Table1State: TStringField;
    Table1Zip: TStringField;
    Table1Country: TStringField;
    Table1Phone: TStringField;
    Table1FAX: TStringField;
    Table1TaxRate: TFloatField;
    Table1Contact: TStringField;
    Table1LastInvoiceDate: TDateTimeField;
    Table2: TTable;
    procedure Table1CustNoValidate(Sender: TField);
    procedure Table1BeforePost(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Table1CustNoValidate(Sender: TField);
begin
if Table1CustNo.AsInteger < 1000 then
  raise EInvalidCustNoException.Create('Customer numbers must be greater than 1000');
end;

procedure TForm1.Table1BeforePost(DataSet: TDataSet);
begin
if Table1.State = dsInsert then
  if Table2.FindKey([Table1Company.AsString]) then
    raise EDuplicateCustomer.Create(Table1Company.AsString + ' is already in the Customer table');
end;

end.
