{ Copyright (c) 1999 by Hagen Reddmann
  mailto:HaReddmann@AOL.COM

  This is the Main Formular for Demo, Delphi Encryption Compendium Part I

  Define 'UseINT64' for Delphi 4
  }
  
unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, Buttons, HCMngr;

type
{$IFNDEF UseINT64}
  TULargeInteger = TLargeInteger;
{$ENDIF}
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    MItemFile: TMenuItem;
    MItemStats: TMenuItem;
    MItemHashMemory: TMenuItem;
    MItemHashFile: TMenuItem;
    MItemExit: TMenuItem;
    P1: TPanel;
    Bevel1: TBevel;
    LHash: TLabel;
    EHashFile: TEdit;
    LInputfile: TLabel;
    BtnHashFile: TBitBtn;
    CBHash: TComboBox;
    LHAlgorithm: TLabel;
    HashManager: THashManager;
    LHashInfo: TLabel;
    LBase16: TLabel;
    EBase16: TEdit;
    LBase64: TLabel;
    EBase64: TEdit;
    BtnCalcHash: TBitBtn;
    OpenDialog: TOpenDialog;
    LHashTimes: TLabel;
    LHashTime: TLabel;
    LCipher: TLabel;
    Bevel2: TBevel;
    CipherManager: TCipherManager;
    LCInput: TLabel;
    LCAlgorithm: TLabel;
    LCipherInfo: TLabel;
    LCKey: TLabel;
    LHashKey: TLabel;
    LCTimes: TLabel;
    LEncodeTime: TLabel;
    ECipherFile: TEdit;
    BtnInputFile: TBitBtn;
    CBCipher: TComboBox;
    EKey: TEdit;
    EHashKey: TEdit;
    BtnCipher: TBitBtn;
    CBCipherMode: TComboBox;
    LCMode: TLabel;
    LModeInfo: TLabel;
    LCipherHint: TLabel;
    BtnViewHashFile: TBitBtn;
    BtnViewCipherFiles: TBitBtn;
    LDTimes: TLabel;
    LDecodeTime: TLabel;
    LHashInput: TLabel;
    EHashInput: TEdit;
    EHashDEC: TEdit;
    LHashDEC: TLabel;
    EHashENC: TEdit;
    LHashENC: TLabel;
    N2: TMenuItem;
    MItemTestFile: TMenuItem;
    MItemTestRes: TMenuItem;
    N1: TMenuItem;
    MItemCipherMemory: TMenuItem;
    MItemCipherFile: TMenuItem;
    MItemMemCBC: TMenuItem;
    MItemMemCTS: TMenuItem;
    MItemMemCFB: TMenuItem;
    MItemMemOFB: TMenuItem;
    MItemMemECB: TMenuItem;
    MItemFileCTS: TMenuItem;
    MItemFileCBC: TMenuItem;
    MItemFileCFB: TMenuItem;
    MItemFileOFB: TMenuItem;
    MItemFileECB: TMenuItem;
    MItemHashVector: TMenuItem;
    MItemCipherVector: TMenuItem;
    procedure MItemExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CBHashClick(Sender: TObject);
    procedure BtnCalcHashClick(Sender: TObject);
    procedure BtnHashFileClick(Sender: TObject);
    procedure CBCipherClick(Sender: TObject);
    procedure CBCipherModeClick(Sender: TObject);
    procedure BtnViewHashFileClick(Sender: TObject);
    procedure EHashFileChange(Sender: TObject);
    procedure BtnInputFileClick(Sender: TObject);
    procedure BtnViewCipherFilesClick(Sender: TObject);
    procedure ECipherFileChange(Sender: TObject);
    procedure BtnCipherClick(Sender: TObject);
    procedure EKeyChange(Sender: TObject);
    procedure MItemTestFileClick(Sender: TObject);
    procedure MItemTestResClick(Sender: TObject);
    procedure MItemHashSpeedClick(Sender: TObject);
    procedure MItemCipherMemSpeedClick(Sender: TObject);
    procedure MItemCipherFileSpeedClick(Sender: TObject);
    procedure MItemHashVectorClick(Sender: TObject);
    procedure MItemCipherVectorClick(Sender: TObject);
  private
    FTime: TULargeInteger;
    FViewer: String;
    FENCFile: String;
    FDECFile: String;
    function SelectFile(Edit: TEdit): Boolean;
    procedure ExecuteView(const FileName: String);
    function Counter(Size: Integer): String;
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

uses ShellAPI, Hash, Cipher, ResFrm, MemSpd, ClipBrd;
{$R *.DFM}

function GetFileSize(const Filename: String): Integer;
var
  SR: TSearchRec;
begin
  if FindFirst(Filename, faAnyFile, SR) = 0 then Result := SR.Size
    else Result := -1;
  FindClose(SR);
end;

procedure TMainForm.ExecuteView(const FileName: String);
begin
  if FileExists(FileName) then
    ShellExecute(Handle, nil, PChar(FViewer), PChar(Filename), nil, sw_ShowNormal);
end;

function TMainForm.SelectFile(Edit: TEdit): Boolean;
begin
  OpenDialog.InitialDir := ExtractFilePath(Edit.Text);
  if OpenDialog.InitialDir = '' then OpenDialog.InitialDir := ExtractFilepath(ParamStr(0));
  Result := OpenDialog.Execute;
  if Result then Edit.Text := OpenDialog.FileName;
end;

function TMainForm.Counter(Size: Integer): String;
var
  D: TULargeInteger;
  S: Double;
begin
  if Size >= 0 then
  begin
    QueryPerformanceCounter(TLargeInteger(D));
    FTime.QuadPart := D.QuadPart - FTime.QuadPart;
    QueryPerformanceFrequency(TLargeInteger(D));
    S := FTime.QuadPart / D.QuadPart;
    Result := FormatFloat('#,###0.0000 Seconds,  ', S) +
              FormatFloat('#0 ms,   ', S * 1000) +
              Format('%d Bytes, %s Kb Datasize  ', [Size, FormatFloat('#,##0.00', Size / 1024)]) +
              FormatFloat('ca #,##0.00 Mb/sec', (1 / S) * (Size / (1024 * 1024)));
  end else
  begin
    Result := '';
    QueryPerformanceCounter(TLargeInteger(FTime));
  end;
end;

procedure TMainForm.MItemExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  if not Hash.InitTestIsOk then Caption := 'Init Test failed';

  FViewer := 'notepad.exe';
  FENCFile := ChangeFileExt(ParamStr(0), '.enc');
  FDECFile := ChangeFileExt(ParamStr(0), '.dec');
  EHashFile.Text := ParamStr(0);
  ECipherFile.Text := EHashFile.Text;

  HashManager.GetHashList(CBHash.Items);
  CBHash.ItemIndex := 0;
  CBHashClick(CBHash);
  CipherManager.GetCipherList(CBCipher.Items);
  CBCipher.ItemIndex := 0;
  CBCipherClick(CBCipher);
  CBCipherMode.ItemIndex := 0;
  CBCipherModeClick(CBCipherMode);
end;

procedure TMainForm.CBHashClick(Sender: TObject);
begin
{1. Variant to select the Hash}
  HashManager.Algorithm := CBHash.Text;
  LHashInfo.Caption := HashManager.Description + ', ' +
                       HashManager.HashClass.ClassName;

{2.Variant }
//  HashManager.HashClass := THashClass(CBHash.Items.Objects[CBHash.ItemIndex]);
//  LHashInfo.Caption := Format('%s, %d bit Digestsize',
//    [HashManager.HashClass.ClassName, HashManager.HashClass.DigestKeySize * 8]);

// Test the Hash of correct Results
  try
    if not HashManager.HashClass.SelfTest then
      MessageBox(Handle, 'Self Test failed', 'Hash Self Test', mb_Ok);
  except
// Abstract Error when THash.TestVector not override
    Application.HandleException(Self);
  end;
  BtnCalcHashClick(nil);
end;                

procedure TMainForm.BtnCalcHashClick(Sender: TObject);
var
  FileSize: Integer;
//  Hash: THash;
//  HashClass: THashClass;
//  Digest: String;
//  Stream: TFileStream;
//  Buf: array[0..7] of Integer;
//  Len: Integer;
begin
  EKeyChange(nil);  {update the Display from Cipherkey}
  EBase16.Text := '';
  EBase64.Text := '';
  FileSize := GetFileSize(EHashFile.Text);
  if FileSize >= 0 then
  try
      Screen.Cursor := crHourglass;
      Application.ProcessMessages;
      Counter(-1);

{1. Variant to Calculate the File with use THashManager}

    HashManager.CalcFile(EHashFile.Text);

      LHashTime.Caption := Counter(FileSize);
      EBase16.Text := HashManager.DigestBase16;
      EBase64.Text := HashManager.DigestBase64;


{2. Variant, we use a LongString to hold the Digest, Digest is binary }
{
      HashClass := HashManager.HashClass;

    SetLength(Digest, HashClass.DigestKeySize);
    HashClass.CalcFile(PChar(Digest), EHashFile.Text);

//  or   THash_MD5.CalcFile(PChar(Digest), EHashFile.Text) , thats all :-)

//  or   EBase64.Text := THash_RipeMD160.CalcFile(nil, EHashFile.Text);

      LHashTime.Caption := Counter(FileSize);
      EBase16.Text := StrToBase16(PChar(Digest), Length(Digest));
      EBase64.Text := StrToBase64(PChar(Digest), Length(Digest));
}

{3. Variant, the conventional Method by allocating an Objectinstance}
{
    Stream := TFileStream.Create(EHashFile.Text, fmOpenRead or fmShareDenyNone);

//    Hash := HashManager.Hash;  or  Hash := THash_MD4.Create;  or

    Hash := HashManager.HashClass.Create;
    try
      Hash.Init;
      repeat
        Len := Stream.Read(Buf, SizeOf(Buf));
        Hash.Calc(Buf, Len);
      until Len <= 0;
// here can other Calc's to chaining the Hash
      Hash.Done;

        LHashTime.Caption := Counter(Stream.Size);
        EBase16.Text := StrToBase16(Hash.DigestKey, Hash.DigestKeySize);
        EBase64.Text := StrToBase64(Hash.DigestKey, Hash.DigestKeySize);

    finally
      Stream.Free;
      Hash.Free;  // when use HashManager.Hash then destroy not !!!
    end;
}
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TMainForm.BtnHashFileClick(Sender: TObject);
begin
  if SelectFile(EHashFile) then BtnCalcHashClick(nil);
end;

procedure TMainForm.BtnViewHashFileClick(Sender: TObject);
begin
  ExecuteView(EHashFile.Text);
end;

procedure TMainForm.EHashFileChange(Sender: TObject);
begin
  BtnViewHashFile.Enabled := FileExists(EHashFile.Text);
  BtnCalcHash.Enabled := FileExists(EHashFile.Text);
end;

procedure TMainForm.CBCipherClick(Sender: TObject);
begin
{1. Variant to set the Cipher}
  CipherManager.Algorithm := CBCipher.Text;

  LCipherInfo.Caption := CipherManager.Description + ', ' +
                         CipherManager.CipherClass.ClassName;

{2.Variant }
//  CipherManager.CipherClass := TCipherClass(CBCipher.Items.Objects[CBCipher.ItemIndex]);

//  LCipherInfo.Caption := Format('%s, %d bit MaxKeysize',
//    [CipherManager.CipherClass.ClassName, CipherManager.CipherClass.KeySize * 8]);


// Test the Cipher of correct Results
  try
    if not CipherManager.CipherClass.SelfTest then
      MessageBox(Handle, 'Self Test failed', 'Cipher Self Test', mb_Ok);
  except
// Abstract Error when TCipher.TestVector not override
    Application.HandleException(Self);
  end;
  BtnCipherClick(nil);
end;

procedure TMainForm.CBCipherModeClick(Sender: TObject);
const
  sMode : array[TCipherMode] of String =
    ('Cipher Text Stealing', 'Cipher Block Chaining', 'Cipher Feedback',
     'Output Feedback', 'Electronic Code Book');
begin
  CipherManager.Mode := TCipherMode(CBCipherMode.ItemIndex);
  LModeInfo.Caption := sMode[CipherManager.Mode];
  BtnCipherClick(nil);
end;

procedure TMainForm.BtnInputFileClick(Sender: TObject);
begin
  if SelectFile(ECipherFile) then BtnCipherClick(nil);
end;

procedure TMainForm.BtnViewCipherFilesClick(Sender: TObject);
begin
  ExecuteView(ECipherFile.Text);
  ExecuteView(FENCFile);
  ExecuteView(FDECFile);
end;

procedure TMainForm.ECipherFileChange(Sender: TObject);
begin
  BtnViewCipherFiles.Enabled := FileExists(ECipherFile.Text);
  BtnCipher.Enabled := FileExists(ECipherFile.Text);
end;

procedure TMainForm.EKeyChange(Sender: TObject);
begin
{will automatically update the Display, the hashed value from Key}
{use the selected HashClass, it's same that use the CipherManager to en/decode}
  DefaultDigestStringFormat := 16; //set the DigestStringFormt to Hexadecimal
  EHashKey.Text := HashManager.HashClass.CalcString(nil, EKey.Text);
  DefaultDigestStringFormat := 64; //set the DigestStringFormt back to MIME Base 64

{ this shows the encoded Hashvalue}
{
  CipherManager.InitKey(EKey.Text, nil);
  EHashKey.Text := CipherManager.Cipher.Hash.DigestBase16;
}
end;

procedure TMainForm.BtnCipherClick(Sender: TObject);
var
  FileSize: Integer;
begin
  EHashInput.Text := '';
  EHashENC.Text   := '';
  EHashDEC.Text   := '';
  FileSize := GetFileSize(ECipherFile.Text);
  if FileSize > 0 then
  try
      Screen.Cursor := crHourGlass;
      Application.ProcessMessages;

// Set to True, the encrypted File included at first the encrypted Hash-Value from Key
// DecodeFile read this out and compares with the actual Hash, is this not equal the
// Key is not valid, IncludeHashKey works when you use InitKey() and En/DecodeFile or
// En/DecodeStream not with Init(), En/DecodeBuffer or En/DecodeString
//    CipherManager.IncludeHashKey := True;

// Init the Key
    CipherManager.InitKey(EKey.Text, nil);
      Counter(-1);
// Encode Input-File to Demo.enc
    CipherManager.EncodeFile(ECipherFile.Text, FENCFile);
      LEncodeTime.Caption := Counter(FileSize);

// Init the Key
    CipherManager.InitKey(EKey.Text, nil);
  //  CipherManager.Cipher.Done;
      Counter(-1);
// Decode Demo.enc to Demo.dec
    CipherManager.DecodeFile(FENCFile, FDECFile);
      LDecodeTime.Caption := Counter(FileSize);

// Verifying the Process with Hash's
      EHashInput.Text := THash_MD4.CalcFile(nil, ECipherFile.Text);
      EHashENC.Text   := THash_MD4.CalcFile(nil, FENCFile);
      EHashDEC.Text   := THash_MD4.CalcFile(nil, FDECFile);
      if EHashInput.Text <> EHashDEC.Text then EHashDEC.Color := clRed
        else EHashDEC.Color := clBtnHighlight;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TMainForm.MItemTestFileClick(Sender: TObject);
var
  A: array[0..255] of Integer;
  I,T: Integer;
begin
  EHashFile.Text := ChangeFileExt(ParamStr(0), '.tst');
  ECipherFile.Text := EHashFile.Text;
  for I := 0 to 255 do A[I] := Random(MaxInt);
  with TFileStream.Create(EHashFile.Text, fmCreate) do
  try
    Screen.Cursor := crHourGlass;
    while Size < 1024 * 1024 do
    begin
      T := Random(MaxInt);
      for I := 0 to 255 do A[I] := A[I] - T;
      Write(A, SizeOf(A));
    end;
  finally
    Free;
    Screen.Cursor := crDefault;
  end;
  BtnCalcHashClick(nil);
  BtnCipherClick(nil);
end;

procedure TMainForm.MItemTestResClick(Sender: TObject);
begin
  with TCheckResForm.Create(Self) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.MItemHashSpeedClick(Sender: TObject);
begin
  with TSpeedForm.Create(Self) do
    Execute(Sender = MItemHashMemory, True, cmECB);
end;

procedure TMainForm.MItemCipherMemSpeedClick(Sender: TObject);
begin
  with TSpeedForm.Create(Self) do
    Execute(True, False, TCipherMode(TComponent(Sender).Tag));
end;

procedure TMainForm.MItemCipherFileSpeedClick(Sender: TObject);
begin
  with TSpeedForm.Create(Self) do
    Execute(False, False, TCipherMode(TComponent(Sender).Tag));
end;

procedure MakeCodeFragment(const Data: String; Len: Integer);
var
  C: String;
  I: Integer;
begin
  C := '         MOV   EAX,OFFSET @Vector' + #13#10 +
       '         RET'                      + #13#10 +
       '@Vector: ';
  for I := 0 to Len -1 do
  begin
    if I mod 8 = 0 then
    begin
      if I > 0 then C := C + #13#10 + '         ';
      C := C + 'DB    ';
    end else C := C + ',';
    C := C + IntToHex(Byte(Data[I+1]), 3) + 'h';
  end;
  Clipboard.AsText := C;
end;

procedure TMainForm.MItemHashVectorClick(Sender: TObject);
{generate the TestVector for the Hash and put a Codefragment to Clipboard}
var
  Data,Caption: String;
begin
  with HashManager.HashClass do
  begin
    SetLength(Data, DigestKeySize);
    CalcBuffer(PChar(Data), GetTestVector^, 32);
    MakeCodeFragment(Data, DigestKeySize);
    Caption := 'Testvector for ' + ClassName;
    Data    := StrToBase16(PChar(Data), DigestKeySize);
    MessageBox(Handle, PChar(Data), PChar(Caption), mb_Ok);
  end;
end;

procedure TMainForm.MItemCipherVectorClick(Sender: TObject);
{generate the TestVector for the Cipher and put a Codefragment to Clipboard}
var
  Data, Caption: String;
begin
  with CipherManager.CipherClass.Create do
  try
    Data := ClassName;
    Mode := cmCTS;
    Init(PChar(Data)^, Length(Data), nil);
    SetLength(Data, 32);
    EncodeBuffer(GetTestVector^, PChar(Data)^, 32);
    MakeCodeFragment(Data, 32);
    Caption := 'Testvector for ' + ClassName;
    Data    := StrToBase16(PChar(Data), 32);
    MessageBox(Handle, PChar(Data), PChar(Caption), mb_Ok);
  finally
    Free;  
  end;
end;

end.
