{***********************************************************
                R&A Library
       Copyright (C) 1996-99 R&A

       description : Register custom useful controls

       programer   : black
       e-mail      : black@infa.ru
       www         : www.chat.ru\~blacknbs\ralib.htm
************************************************************}

{$INCLUDE RA.INC}

unit RACtrlReg;

interface

procedure Register;

implementation
     
uses Classes, DsgnIntf, Controls,
  RAUtils, RAUtilsW, RAStream, RAHook, RAConst, RADsgn,
  RARegAuto, RARegAutoEditor, RACt, RADlg, RAHint, RAScrollBar,
  RATreeView, RAButtons, RACombo, RAComponentPanel, RAScrollMax, RAImage,
  RAEditor, RAHLEditor, RAScrollText, fRAhtHintEditor, RADoubleCombo
 {$IFDEF RA_D3H}
  , Zoom
 {$ENDIF RA_D3H};
                         
{$R RACtrl.dcr}

type

  TRAScrollMaxEditor = class(TComponentEditor)
    function GetVerbCount : integer; override;
    function GetVerb(Index : integer) : string; override;
    procedure ExecuteVerb(Index : integer); override;
    procedure Edit; override;
  end;

function TRAScrollMaxEditor.GetVerbCount : integer;
begin
  Result := inherited GetVerbCount + 1;
end;

function TRAScrollMaxEditor.GetVerb(Index : integer) : string;
begin
  if Index = GetVerbCount - 1 then
    Result := 'Add Band' else
    Result := inherited GetVerb(Index);
end;

procedure TRAScrollMaxEditor.ExecuteVerb(Index : integer);
begin
  if Index = GetVerbCount - 1 then
    Designer.CreateComponent(TRAScrollMaxBand, Component, 0, 0, 0, 50)
  else
    inherited ExecuteVerb(Index);
end;

procedure TRAScrollMaxEditor.Edit;
begin
 // We don't need to add band on double click
end;


procedure Register;
begin
 {RARegAuto unit}
  RegisterComponents('R&&A Controls', [TRegAuto]);
  RegisterComponentEditor(TRegAuto, TRegAutoEditor);
 {RACt unit}
  RegisterComponents('R&&A Controls', [TRegAutoGrid, TRACheckBox, TRAStatusBar,
    TRAhtListBox, TRAhtComboBox, TRAhtLabel]);
  RegisterPropertyEditor(TypeInfo(TCaption), TRAhtLabel, 'Caption', TRAHintProperty);
 {RADlg unit}
  RegisterComponents('R&&A Controls', [TRAProgressForm]);
 {RAEditor unit}
  RegisterComponents('R&&A Controls', [TRAEditor]);
 {RAHLEditor unit}
  RegisterComponents('R&&A Controls', [TRAHLEditor]);
 {RAHint unit}
  RegisterComponents('R&&A Controls', [TRAHint]);
  RegisterPropertyEditor(TypeInfo(string), TObject, 'Hint', TRAHintProperty);
 {RATreeView unit}
  RegisterComponents('R&&A Controls', [TRAComboBox4Tree, TRATreeView]);
 {RAScrollBar unit}
  RegisterComponents('R&&A Controls', [TRAScrollBar, TRAScrollBar95]);
 {RACombo unit}
  RegisterComponents('R&&A Controls', [TRACombo]);
 {RAComponentPanel unit}
  RegisterComponents('R&&A Controls', [TRAComponentPanel]);
 {RAButtons unit}
  RegisterComponents ('R&&A Controls', [TRACaptionButton, TRANoFrameButton,
    TRAColorButton, TRAhtButton]);
 {RAScrollMax unit}
  RegisterComponents('R&&A Controls', [TRAScrollMax]);
  RegisterClass(TRAScrollMaxBand);
  RegisterComponentEditor(TRAScrollMax, TRAScrollMaxEditor);
 {RAImage unit}
  RegisterComponents('R&&A Controls', [TRAImage]);
 {RAScrollText}
  RegisterComponents('R&&A Controls', [TRAScrollText]);
 {RADoubleCombo}
  RegisterComponents('R&&A Controls', [TRADoubleCombo]);
 {Zoom unit}
 {$IFDEF RA_D3H}
  RegisterZoom;
 {$ENDIF RA_D3H}
end;

end.
