unit ReportsServer1_IMPL;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, ComObj, StdVcl,
  CorbaObj, ReportsServer1_TLB, Dialogs;

type

  TReports = class(TCorbaImplementation, IReports)
  private
    { Private declarations }
    ReportList : TStringList;
  public
    { Public declarations }
    constructor Create(Controller: IObject; AFactory: TCorbaFactory);override;
    destructor Destroy; override;
  protected
    function CloseReport(const ReportName: WideString): WordBool; safecall;
    function DoDaysEndReports: WordBool; safecall;
    function GetReport(const ReportName: WideString): WordBool; safecall;
    function PrintReport(const ReportName: WideString): WordBool; safecall;
    function getReportCount: Integer; safecall;
    function ReportIsOpened(const ReportName: WideString): WordBool; safecall;
  end;

implementation

uses CorbInit, FormReportsServerMain;

constructor TReports.Create(Controller: IObject; AFactory: TCorbaFactory);
begin
  inherited Create(Controller,AFactory);
  ReportList := TStringList.Create;
end;

destructor TReports.Destroy;
begin
  ReportList.Free;
  inherited Destroy;
end;

function TReports.CloseReport(const ReportName: WideString): WordBool;
begin
  with ReportList do
  if ReportIsOpened(ReportName) then
  begin
    Delete(IndexOf(ReportName));
    with frmReportsServerMain.lstbxCurrentReports do
      Items.Delete(Items.IndexOf(ReportName));
    result := True;
  end
  else result := False;
end;

function TReports.DoDaysEndReports: WordBool;
begin
  result := True;
end;

function TReports.GetReport(const ReportName: WideString): WordBool;
begin
  if ReportList.IndexOf(ReportName) = -1 then
  begin
    ReportList.Add(ReportName);
    frmReportsServerMain.lstbxCurrentReports.Items.Add(ReportName);
    result := True;
    frmReportsServerMain.stsbrStatus.SimpleText := 'There are currently ' +
                                               IntToStr(ReportList.Count) + ' opened.';
  end
  else result := False;
end;

function TReports.PrintReport(const ReportName: WideString): WordBool;
begin
  result := ReportIsOpened(ReportName);
end;

function TReports.getReportCount: Integer;
begin
  result := ReportList.Count;
  frmReportsServerMain.stsbrStatus.SimpleText := 'There are currently ' + IntToStr(ReportList.Count) +
                                                 ' opened.';
end;

function TReports.ReportIsOpened(const ReportName: WideString): WordBool;
begin
  result := not(ReportList.IndexOf(ReportName) = -1);
end;

initialization
  TCorbaObjectFactory.Create('ReportsFactory', 'Reports', 'IDL:ReportsServer1/ReportsFactory:1.0', IReports,
    TReports, iMultiInstance, tmSingleThread);
end.