{
  Name    :   AccountsDM.pas

  Purpose :   Data module containing database and query support objects for
               the TAccounts object.

  Usage   :   This source code is supplied as example code with Delphi Informant
               magazine.
              The author makes no guarantee for its correctness or fitness
               for any purpose and cannot be held responsible for any loss
               or damage that may occur through its use or misuse.
              You may copy, modify or use any part of this source code
               provided the author is credited for his work.

  Author  :   Paul M. Fairhurst, September 1998. paul@c-s-c.demon.co.uk
}
unit AccountsDM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DelphiBankCommonDM, Db, DBTables;

type
  TdmAccounts = class(TdmDelphiBankCommon)
    QryAccountSelectiveRead: TQuery;
    QryAccountInsert: TQuery;
    QryAccountReadAll: TQuery;
    QryAccountDelete: TQuery;
    QryAccountReadByAcctTypeID: TQuery;
    QryAccountReadByCustID: TQuery;
    QryAccountAddToBalance: TQuery;
    DbDelphiBank: TDatabase;
    procedure dmAccountsCreate(Sender: TObject);
    procedure dmAccountsDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TdmAccounts.dmAccountsCreate(Sender: TObject);
begin
  inherited;
  SetUpDB(DbDelphiBank);
end;

procedure TdmAccounts.dmAccountsDestroy(Sender: TObject);
begin
  inherited;
  DbDelphiBank.Close;
{  sessAccounts.Active := False;}
end;

end.
