{
  Name    :   CustomersDM.pas

  Purpose :   Data module containing database and query support objects for
               the TCustomers object.

  Usage   :   This source code is supplied as example code with Delphi Informant
               magazine.
              The author makes no guarantee for its correctness or fitness
               for any purpose and cannot be held responsible for any loss
               or damage that may occur through its use or misuse.
              You may copy, modify or use any part of this source code
               provided the author is credited for his work.

  Author  :   Paul M. Fairhurst, September 1998. paul@c-s-c.demon.co.uk
}
unit CustomersDM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DelphiBankCommonDM, Db, DBTables;

type
  TdmCustomers = class(TdmDelphiBankCommon)
    QryCustomerSelectiveRead: TQuery;
    QryCustomerInsert: TQuery;
    QryCustomerReadAll: TQuery;
    QryCustomerDelete: TQuery;
    QryCustomerMatchLogon: TQuery;
    DbDelphiBank: TDatabase;
    procedure dmCustomersCreate(Sender: TObject);
    procedure dmCustomersDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TdmCustomers.dmCustomersCreate(Sender: TObject);
begin
  inherited;
  SetUpDB(DbDelphiBank);
end;

procedure TdmCustomers.dmCustomersDestroy(Sender: TObject);
begin
  inherited;
  DbDelphiBank.Close;
{  sessCustomers.Active := False;}
end;

end.
