{
  Name    :   TransactionsDM.pas

  Purpose :   Data module containing database and query support objects for
               the TTransactions object.

  Usage   :   This source code is supplied as example code with Delphi Informant
               magazine.
              The author makes no guarantee for its correctness or fitness
               for any purpose and cannot be held responsible for any loss
               or damage that may occur through its use or misuse.
              You may copy, modify or use any part of this source code
               provided the author is credited for his work.

  Author  :   Paul M. Fairhurst, September 1998. paul@c-s-c.demon.co.uk
}
unit TransactionsDM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DelphiBankCommonDM, Db, DBTables;

type
  TdmTransactions = class(TdmDelphiBankCommon)
    QryTransactionSelectiveRead: TQuery;
    QryTransactionInsert: TQuery;
    QryTransactionReadAll: TQuery;
    QryTransactionDelete: TQuery;
    QryTransactionReadByAcctID: TQuery;
    QryTransactionReadStatementByAcctID: TQuery;
    DbDelphiBank: TDatabase;
    procedure dmTransactionsCreate(Sender: TObject);
    procedure dmTransactionsDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TdmTransactions.dmTransactionsCreate(Sender: TObject);
begin
  inherited;
  SetUpDB(DbDelphiBank);
end;

procedure TdmTransactions.dmTransactionsDestroy(Sender: TObject);
begin
  inherited;
  DbDelphiBank.Close;
{  sessTransactions.Active := False;}
end;

end.
