
unit TransPan;
{
 TTransPan component for Borland DELPHI 2.0, Version 2.0.

 (C) Alexander Gogava, Tbilisi, Rep. of Georgia. 1998.
           E - mail   alex@argosoft.com

      This component can be use like the TPanel in all applications, because
 It has all published and public properties of  the TPanel.

 If You use Delphi 1.0

    To install this component in your VCL place the file TransPan.pas and
 TransPan.16 in your C:\BORLAND\DELPHI20\LIB directory. Rename TransPan.16
 to  TransPan.dcr and from Options menu select Install Components....
 In the Install Components dialogue box click Add Button, then in Add
 Module box type C:\DELPHI\LIB\TransPan.PAS, click OK, then in the Install
 Components Dialogue box click OK again and wait while TransPan icon will
 appear in the Additional section of the your Components Palette.

 If You use Delphi 2.0

    To install this component in your VCL place the file TransPan.pas and
 TransPan.dcr in your C:\BORLAND\DELPHI20\LIB directory and from Component
 menu select Install . In the Install Components dialogue box click Add Button,
 then in Add Module box type C:\BORLAND\DELPHI20\LIB\TransPan.PAS, click OK,
 then in the Install Components Dialogue box click OK again and wait  while
 TransPan icon will appear in the Samples section of the your Components Palette.

 Regards

 Alexander Gogava

 alex@argosoft.com
}
interface
{$IFDEF Win32}
uses
   SysUtils, Windows, Messages, Classes, Graphics, Controls,
   Forms, Dialogs, ExtCtrls, StdCtrls, Menus, DsgnIntf, Buttons;
{$ELSE}
uses
   SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
   Forms, Dialogs, ExtCtrls, StdCtrls, Menus, DsgnIntf, Buttons;
{$ENDIF}

Type
TState = (StPanel, Scramble, Tetris);
TTSKey = (Lft, Rgh, Drp, Rtt, Down, Up);
TColorTShapes = (colorFixed, colorFixed2, colorOne, colorRandom);
TSRowsColumns = 2..8;
TTColumns = 6..20;
TTRows = 6..40;
TTShape = 1..7;

                           {  TScrmbl  }

TScrmbl = class(TCustomPanel)
private
    { Private declarations }
    Timer1: TTimer;
    FOnTime: TNotifyEvent;
    FOnOverS: TNotifyEvent;
    FDragAble: Boolean;
    FPause: Boolean;
    FScrambleKey: TTSKey;
    FColorB: TColor;
    FStart: Boolean;
    FFirstFocus: Boolean;
    str: String[2];
    x, y, he, wi: integer;
    FRowsColumns: TSRowsColumns;
    But: Array[1..8,1..8] of TBitBtn;
    procedure Resize; Override;
    procedure Paint; Override;
    procedure WMNCHitTest(var Mes: TWMNCHitTest); Message WM_NCHitTest;
    procedure ScrambleKeyDown(var Key: Word; Shift: TShiftState);
    procedure ButtonClick(Sender: TObject);
    procedure ButtonKeyDown(Sender: TObject);
    procedure TimerOnTimer(Sender: TObject);
    procedure Time;  Dynamic;
    procedure OverS; Dynamic;
    procedure Detect;
    procedure SLeft;
    procedure SRight;
    procedure SUp;
    procedure SDown;
    procedure SetStart(Value: Boolean);
    procedure SetPause(Value: Boolean);
    procedure SetScrambleKey(Value: TTSKey);
    procedure ShowHide;
    procedure ButtonsInit;
    procedure ButtonsPos;
    procedure ButtonsColors;
    property OnTime: TNotifyEvent read FOnTime write FOnTime;
    property OnOverS: TNotifyEvent read FOnOverS write FOnOverS;
    property Start: Boolean read FStart write SetStart;
    property FirstFocus: Boolean read FFirstFocus;
    property Pause: Boolean read FPause write SetPause;
    property RowsColumns: TSRowsColumns read FRowsColumns write FRowsColumns;
    property ScrambleKey: TTSKey read FScrambleKey write SetScrambleKey;
    constructor Create(AOwner:TComponent); Override;
    destructor Destroy; Override;
end;
 TTtrs = class(TCustomPanel)
private
    { Private declarations }
    Timer1: TTimer;
    Panel1: TPanel;
    FColorB, FColorF, FColorShapesPen: TColor;
    FColorShapes: TColorTShapes;
    FOneColorShapes: TColor;
    FWidthShapesPen: Integer;
    FShapesType: TShapeType;
    FShapesBrushStyle: TBrushStyle;
    FDelay: Cardinal;
    FCongrats, FStart, FPause, FNextSColor: Boolean;
    FNextShape: TTShape;
    FOnDelete, FOnOverT, FOnContact: TNotifyEvent;
    FTetrisKey: TTSKey;
    FFirstFocus: Boolean;
    str: String[2];
    x, he, wi: Word;
    FRows: TTRows;
    FColumns: TTColumns;
    Sh: Array[1..40,1..20] of TShape;
    procedure SetDelay(Value: Cardinal);
    procedure SetStart(Value: Boolean);
    procedure SetPause(Value: Boolean);
    procedure SetColorF(Value: TColor);
    procedure SetColorShapes(Value: TColorTShapes);
    procedure SetOneColorShapes(Value: TColor);
    procedure SetColorShapesPen(Value: TColor);
    procedure SetWidthShapesPen(Value: Integer);
    procedure SetShapesType(Value: TShapeType);
    procedure SetShapesBrushStyle(Value: TBrushStyle);
    procedure SetRows(Value: TTRows);
    procedure SetColumns(Value: TTColumns);
    procedure SetNextShape(Value: TTShape);
    procedure SetNextSColor(Value: Boolean);
    procedure SetTetrisKey(Value: TTSKey);
    procedure Paint; Override;
    procedure Resize; Override;
    procedure WMNCHitTest(var Mes: TWMNCHitTest); Message WM_NCHitTest;
    procedure TetrisKeyDown(var Key: Word; Shift: TShiftState);
    procedure TimerOnTimer(Sender: TObject);
    procedure CreateShapes;
    procedure Left;
    procedure Right;
    procedure Rotate;
    procedure DropDown;
    procedure CreateShape(var Shape: TShape; i, j, r: ShortInt);
    procedure Delete; dynamic;
    procedure Contact; dynamic;
    procedure OverT; dynamic;
    procedure EndFlying;
    property ColorF: TColor read FColorF write SetColorF;
    property Start: Boolean read FStart write SetStart;
    property Pause: Boolean read FPause write SetPause;
    property FirstFocus: Boolean read FFirstFocus;
    property TetrisKey: TTSKey read FTetrisKey write SetTetrisKey;
    property NextSColor: Boolean read FNextSColor write SetNextSColor;
    property NextShape: TTShape read FNextShape write SetNextShape;
    property ColorShapes: TColorTShapes read FColorShapes write SetColorShapes;
    property OneColorShapes: TColor read FOneColorShapes write SetOneColorShapes;
    property ShapesType: TShapeType read FShapesType write SetShapesType;
    property ShapesBrushStyle: TBrushStyle read FShapesBrushStyle write SetShapesBrushStyle;
    property ColorShapesPen: TColor read FColorShapesPen write SetColorShapesPen;
    property WidthShapesPen: Integer read FWidthShapesPen write SetWidthShapesPen;
    property OnOverT: TNotifyEvent read FOnOverT write FOnOverT;
    property OnContact: TNotifyEvent read FOnContact write FOnContact;
    property OnDelete: TNotifyEvent read FOnDelete write FOnDelete;
    property Delay: Cardinal read FDelay write SetDelay;
    property Rows: TTRows read FRows write FRows;
    property Columns: TTColumns read FColumns write FColumns;
    constructor Create(AOwner: TComponent); Override;
    destructor Destroy; Override;
end;

                                {  TTransPan  }

TTransPan = class(TCustomPanel)
private
    Scrmbl1: TScrmbl;
    Ttrs1: TTtrs;
    FAbout, FTCaption, FSCaption: String;
    fx, fy, fcx, fcy, FWidthTShapesPen : Integer;
    FLines : Word;
    FTime: Real;
    FStyle: Longint;
    FShowTScores, FWithCaption: Boolean;
    FState: TState;
    FShowSTime, FStartS, FStartT, FPauseS, FPauseT, FNextSColorT: Boolean;
    FTCoeff, FTScores  : Integer;
    FDelayT : Cardinal;
    FTKey: TTSKey;
    FSKey: TTSKey;
    FNextTShape: TTShape;
    FColorTB, FColorSB, FColorTF, FColorTShapesPen, FOneColorTShapes: TColor;
    FColorTShapes : TColorTShapes;
    FShapesTType: TShapeType;
    FShapesTBrushStyle: TBrushStyle;
    FOnScrambleOver, FOnScrambleTime, FOnTetrisOver,
    FOnTetrisDeleteLine, FOnTetrisContact, FOnTetrisSet: TNotifyEvent;
    FTRows: TTRows;
    FTColumns: TTColumns;
    FSRowsColumns: TSRowsColumns;
    procedure SetState(Value: TState);
    procedure SetStartT(Value: Boolean);
    procedure SetStartS(Value: Boolean);
    procedure SetPauseT(Value: Boolean);
    procedure SetPauseS(Value: Boolean);
    procedure SetTKey(Value: TTSKey);
    procedure SetSKey(Value: TTSKey);
    procedure SetColorTF(Value: TColor);
    procedure SetColorTB(Value: TColor);
    procedure SetOneColorTShapes(Value: TColor);
    procedure SetColorTShapes(Value: TColorTShapes);
    procedure SetShapesTType(Value: TShapeType);
    procedure SetShapesTBrushStyle(Value: TBrushStyle);
    procedure SetColorTShapesPen(Value: TColor);
    procedure SetWidthTShapesPen(Value: Integer);
    procedure SetColorSB(Value: TColor);
    procedure SetDelayT(Value: Cardinal);
    procedure SetNextSColorT(Value: Boolean);
    procedure SetNextTShape(Value: TTShape);
    procedure SetShowSTime(Value: Boolean);
    procedure SetShowTScores(Value: Boolean);
    procedure ChangeState;
    procedure ChangeParams;
    procedure TransPanKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure TetrisDeleteLine(Sender: TObject);
    procedure TetrisOver(Sender: TObject);
    procedure TetrisContact(Sender: TObject);
    procedure TetrisSet;
    procedure ScrambleOver(Sender: TObject);
    procedure ScrambleTime(Sender: TObject);
    procedure SetSRowsColumns(Value: TSRowsColumns);
    procedure SetTRows(Value: TTRows);
    procedure SetTColumns(Value: TTColumns);
    procedure SetTCaption(Value: String);
    procedure SetWithCaption(Value: Boolean);
    procedure SetSCaption(Value: String);
    procedure SetTCoeff(Value: Integer);
    procedure PanelSetFocus;
protected
public
    constructor Create(AOwner: TComponent); Override;
    destructor Destroy; Override;
    property PauseS: Boolean read FPauseS write SetPauseS default False;
    property PauseT: Boolean read FPauseT write SetPauseT default False;
    property NextTShape: TTShape read FNextTShape write SetNextTShape default 7;
    property TKey: TTSKey read FTKey write SetTKey;
    property SKey: TTSKey read FSKey write SetSKey;
    property Time: Real read FTime;
    property Lines: Word read FLines default 0;
    property TScores: Integer read FTScores default 0;
published
    property About: String read FAbout write FAbout stored False;
    property Align;
    property Alignment;
    property BevelInner;
    property BevelOuter;
    property BorderStyle;
    property BorderWidth;
    property Caption;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property Locked;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;

    property ColorSB: TColor read FColorSB write SetColorSB default clBtnFace;
    property ColorTB: TColor read FColorTB write SetColorTB default clBtnFace;
    property ColorTF: TColor read FColorTF write SetColorTF default clBlack;
    property ColorTShapes: TColorTShapes read FColorTShapes write SetColorTShapes default colorFixed;
    property ColorTShapesPen: TColor read FColorTShapesPen write SetColorTShapesPen default clWhite;
    property DelayT: Cardinal read FDelayT write SetDelayT default 200;
    property NextSColorT: Boolean read FNextSColorT write SetNextSColorT default False;
    property OneColorTShapes: TColor read FOneColorTShapes write SetOneColorTShapes default clBlack;
    property SRowsColumns: TSRowsColumns read FSRowsColumns write SetSRowsColumns default 4;
    property State: TState read FState write SetState default stPanel;
    property StartT: Boolean read FStartT write SetStartT default False;
    property StartS: Boolean read FStartS write SetStartS default False;
    property ShapesTType: TShapeType read FShapesTType write SetShapesTType default stRoundRect;
    property ShapesTBrushStyle: TBrushStyle read FShapesTBrushStyle write SetShapesTBrushStyle default bsSolid;
    property ShowTScores: Boolean read FShowTScores write SetShowTScores default True;
    property ShowSTime: Boolean read FShowSTime write SetShowSTime default True;
    property SCaption: String read FSCaption write SetSCaption;
    property TCoeff: Integer read FTCoeff write SetTCoeff default 1;
    property TCaption: String read FTCaption write SetTCaption;
    property TRows: TTRows read FTRows write SetTRows default 20;
    property TColumns: TTColumns read FTColumns write SetTColumns default 10;
    property WidthTShapesPen: Integer read FWidthTShapesPen write SetWidthTShapesPen default 1;
    property WithCaption: Boolean read FWithCaption write SetWithCaption default True;
    property OnScrambleOver: TNotifyEvent read FOnScrambleOver write FOnScrambleOver;
    property OnScrambleTime: TNotifyEvent read FOnScrambleTime write FOnScrambleTime;
    property OnTetrisOver: TNotifyEvent read FOnTetrisOver write FOnTetrisOver;
    property OnTetrisDeleteLine: TNotifyEvent read FOnTetrisDeleteLine write FOnTetrisDeleteLine;
    property OnTetrisContact: TNotifyEvent read FOnTetrisContact write FOnTetrisContact;
    property OnTetrisSet: TNotifyEvent read FOnTetrisSet write FOnTetrisSet;
end;

                             { Register }

procedure Register;

implementation

                           { TAboutProperty }
type
TAboutProperty = class(TStringProperty)
protected
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
end;

var
temp: String;
m,n,ni,nj,i,j,num: ShortInt;
KeyUsed: Boolean;

                              { Register }

procedure Register;
begin
  RegisterComponents('Additional', [TTransPan]);
  RegisterPropertyEditor(TypeInfo(String), TTransPan, 'About',
  TAboutProperty);
end;

                            { TAboutProperty }

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paReadOnly, paDialog];
end;

procedure TAboutProperty.Edit;
begin
  ShowMessage(' Alexander Gogava 1998');
end;

                                { TScrmbl }

constructor TScrmbl.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
    Timer1:=TTimer.Create(Self);
    Timer1.Interval:=100;
    Timer1.OnTimer:=TimerOnTimer;
    Timer1.Enabled:=False;
end;

destructor TScrmbl.Destroy;
begin
  for i:=1 to FRowsColumns do
  for j:=1 to FRowsColumns do
  if But[i,j]<> nil then But[i,j].Free;
  if Timer1<>nil then Timer1.Free;
  Inherited Destroy;
end;

procedure TScrmbl.Paint;
begin
inherited Paint;
if not FFirstFocus then
begin if CanFocus then SetFocus; FFirstFocus:=True; end;
end;

procedure TScrmbl.Resize;
begin
inherited Resize;
if FStart=False then Exit;
  he:=Trunc(Height div FRowsColumns);
  wi:=Trunc(Width div FRowsColumns);
  x:=(Width-wi*FRowsColumns) div 2;
  y:=(Height-he*FRowsColumns) div 2;
    for i:=1 to FRowsColumns do
    for j:=1 to FRowsColumns do
    if But[i,j]<>nil then
    But[i,j].SetBounds(wi*Pred(j)+x,he*Pred(i)+y,wi,he);
end;

procedure TScrmbl.ButtonsInit;
begin
for i:=1 to FRowsColumns do
for j:=1 to FRowsColumns do
if But[i,j]<>nil then begin But[i,j].Free; But[i,j]:=nil; end;
  he:=Trunc(Height div FRowsColumns);
  wi:=Trunc(Width div FRowsColumns);
  x:=(Width-wi*FRowsColumns) div 2;
  y:=(Height-he*FRowsColumns) div 2;
for i:=1 to FRowsColumns do
for j:=1 to FRowsColumns do
begin
if But[i,j]=nil then But[i,j]:=TBitBtn.Create(Self);
With But[i,j] do
  begin
  Parent:=Self;
  Hide;
  Tag:=Pred(i)*FRowsColumns+j;
  Caption:=InttoStr(Tag);
  Name:='bitbtn'+Caption;
  OnClick:=ButtonClick;
  SetBounds(wi*Pred(j)+x,he*Pred(i)+y,wi,he);
  TabStop:=False;
  end;
end;
end;

procedure TScrmbl.ButtonsPos;
var
l,max: Integer;
temp: Shortint;
begin
num:=Sqr(FRowsColumns); str:=InttoStr(num);
Randomize;
max:=10000+Random(10000);
i:=FRowsColumns; j:=FRowsColumns;
for l:=1 to max do
   begin
   m:=Random(2);
   n:=Pred(m*2);
   ni:=i+n; nj:=j+n;
   if (nj in [1..FRowsColumns])  then
                      begin
                      But[i,j].Tag:=But[i,nj].Tag;
                      But[i,nj].Tag:=num;
                      temp:=j; j:=nj; nj:=temp;
                      end
   else
   if (ni in [1..FRowsColumns])  then
                      begin
                      But[i,j].Tag:=But[ni,j].Tag;
                      But[ni,j].Tag:=num;
                      temp:=i; i:=ni; ni:=temp;
                      end;
   end;
for i:=1 to FRowsColumns do
for j:=1 to FRowsColumns do
   begin
   But[i,j].Caption:=IntToStr(But[i,j].Tag);
   if But[i,j].Tag<>num then But[i,j].Show;
   end;
end;

procedure TScrmbl.ButtonsColors;
begin
num:=Sqr(FRowsColumns);
for i:=1 to FRowsColumns do
for j:=1 to FRowsColumns do
   begin
   if (But[i,j].Caption=IntToStr(j+Pred(i)*FRowsColumns)) then
   But[i,j].Font.Color:=clGreen else But[i,j].Font.Color:=clRed;
   if (But[i,j].Tag<>num) then But[i,j].Show;
   end;
end;

procedure TScrmbl.SetStart(Value: Boolean);
begin
if FStart<>Value then FStart:=Value;
if FStart=True then
    begin
    ButtonsInit;
    ButtonsPos;
    ButtonsColors;
    FFirstFocus:=False;
    if Timer1<>nil then Timer1.Enabled:=True;
    end;
end;

procedure TScrmbl.SetScrambleKey(Value: TTSKey);
begin
if FScrambleKey<>Value then FScrambleKey:=Value;
     Case FScrambleKey of
     Lft: SLeft;
     Rgh: SRight;
     Down: SDown;
     Up: SUp;
     end;
end;

procedure TScrmbl.SetPause(Value: Boolean);
begin
if FPause<>Value then FPause:=Value;
if not FStart then exit;
if FPause then
   begin
   if Timer1<>nil then Timer1.Enabled:=False;
   for i:=1 to FRowsColumns do
   for j:=1 to FRowsColumns do
   if But[i,j]<>nil then But[i,j].enabled:=False;
   end
else
   begin
   if Timer1<>nil then Timer1.Enabled:=True;
   for i:=1 to FRowsColumns do
   for j:=1 to FRowsColumns do
   if But[i,j]<>nil then But[i,j].enabled:=True;
   end;
end;

procedure TScrmbl.SLeft;
begin
        for i:=1 to FRowsColumns do
        for j:=2 to FRowsColumns do
        if But[i,Pred(j)].Visible=False then
        begin But[i,j].SetFocus; ButtonKeyDown(But[i,j]); exit; end;
end;

procedure TScrmbl.SRight;
begin
        for i:=1 to FRowsColumns do
        for j:=1 to Pred(FRowsColumns) do
        if But[i,Succ(j)].Visible=False then
        begin But[i,j].SetFocus; ButtonKeyDown(But[i,j]); exit; end;
end;

procedure TScrmbl.SUp;
begin
        for j:=1 to FRowsColumns do
        for i:=2 to FRowsColumns do
        if But[Pred(i),j].Visible=False then
        begin But[i,j].SetFocus; ButtonKeyDown(But[i,j]); exit; end;
end;

procedure TScrmbl.SDown;
begin
        for j:=1 to FRowsColumns do
        for i:=1 to Pred(FRowsColumns) do
        if But[Succ(i),j].Visible=False then
        begin But[i,j].SetFocus; ButtonKeyDown(But[i,j]); exit; end;
end;

procedure TScrmbl.ScrambleKeyDown(var Key: Word; Shift: TShiftState);
begin
if FPause=True then exit;
   Case Key of
   vk_numpad2: SDown;
   vk_numpad4: SLeft;
   vk_numpad6: SRight;
   vk_numpad8: SUp;
   end;
end;

procedure TScrmbl.TimerOnTimer(Sender: TObject);
begin
if FStart then Time;
end;

procedure TScrmbl.Time;
begin
if assigned(FOnTime) then FOnTime(Self);
end;

procedure TScrmbl.Detect;
var
k: ShortInt;
begin
k:=0;
for i:=1 to FRowsColumns do
for j:=1 to FRowsColumns do
if But[i,j].Font.Color=clGreen then Inc(k);
if (k=Sqr(FRowsColumns)-1) then OverS;
end;

procedure TScrmbl.ShowHide;
label lab;
begin
if KeyUsed then goto lab;
for i:=1 to FRowsColumns do
for j:=1 to FRowsColumns do
begin
 if (But[i,j].focused) then
  begin
  lab:
  for m:=0 to 1 do
  begin
  n:=Pred(m*2);
  nj:=j+n; ni:=i+n;
  if(nj in [1..FRowsColumns])then
  if (But[i,nj].Caption=Str)
  then begin
       But[i,nj].Caption:=But[i,j].Caption;
       if (But[i,nj].Caption=IntToStr(nj+Pred(i)*FRowsColumns)) then
       But[i,nj].Font.Color:=clGreen else But[i,nj].Font.Color:=clRed;
       But[i,nj].Show;
       But[i,j].Hide;
       But[i,j].Caption:=Str;
       exit;
       end;
  if (ni in [1..FRowsColumns]) then
  if (But[ni,j].Caption=Str)
  then begin
       But[ni,j].Caption:=But[i,j].Caption;
       if (But[ni,j].Caption=IntToStr(j+Pred(ni)*FRowsColumns)) then
       But[ni,j].Font.Color:=clGreen else But[ni,j].Font.Color:=clRed;
       But[ni,j].Show;
       But[i,j].Hide;
       But[i,j].Caption:=Str;
       exit;
       end;
  end;
  end;
end;
end;

procedure TScrmbl.ButtonKeyDown(Sender: TObject);
begin
KeyUsed:=True;
ShowHide;
SetFocus;
Detect;
end;

procedure TScrmbl.ButtonClick(Sender: TObject);
begin
KeyUsed:=False;
ShowHide;
SetFocus;
Detect;
end;

procedure TScrmbl.WMNCHitTest(var Mes: TWMNCHitTest);
begin
inherited;
  if Mes.Result=htClient
  then Mes.Result:=htCaption;
SetFocus;
end;

procedure TScrmbl.OverS;
begin
for i:=1 to FRowsColumns do
for j:=1 to FRowsColumns do
if But[i,j]<>nil then But[i,j].Hide;
if assigned(FOnOverS) then FOnOverS(Self);
SetFocus;
end;

                               { TTtrs }

constructor TTtrs.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
FStart:=False;
Timer1:=TTimer.Create(Self);
Timer1.OnTimer:=TimerOnTimer;
Randomize;
Panel1:=TPanel.Create(Self);
With Panel1 do
       begin
       Parent:=Self;
       Align:=alBottom;
       BevelInner:=bvNone;
       BevelOuter:=bvRaised;
       BorderStyle:=bsSingle;
       Color:=ColorF;
       Height:=0;
       end;
for i:=1 to FRows do
for j:=1 to FColumns do
Sh[i,j]:=nil;
end;

destructor TTtrs.Destroy;
begin
if Timer1<>nil then begin Timer1.Free; Timer1:=nil; end;
if Panel1<>nil then begin Panel1.Free; Panel1:=nil; end;
for i:=1 to FRows do
for j:=1 to FColumns do
if Sh[i,j]<>nil then begin Sh[i,j].Free; Sh[i,j]:=nil; end;
Inherited Destroy;
end;

procedure TTtrs.TimerOnTimer(Sender: TObject);
var
k, i1: ShortInt;
ii,jj: array [1..4] of Shortint;
Cont: boolean;
begin
k:=0;
Cont:=false;
for j:=1 to FColumns do
for i:=FRows downto 1 do
if Sh[i,j]<>nil then if Sh[i,j].Tag<>0 then
    begin
    Inc(k);
    ii[k]:=i; jj[k]:=j;
    i1:=Succ(i);
    if (i=FRows) or ((Sh[i1,j]<>nil)and(Sh[i1,j].Tag=0))then Cont:=true;
    if k=4 then break;
    end;
if k=4 then
  begin
    if Cont then
    begin
    for k:=1 to 4 do
    begin
    i:=ii[k]; j:=jj[k];
    Sh[i,j].Tag:=0;
    end;
    EndFlying;
    end
  else
  for k:=1 to 4 do
    begin
    i:=ii[k]; j:=jj[k];
    i1:=Succ(i);
    Sh[i1,j]:=TShape.Create(Self);
    CreateShape(Sh[i1,j], i1, j, Sh[i,j].Tag);
    Sh[i,j].Free;
    Sh[i,j]:=nil;
    end;
  end;
end;

procedure TTtrs.CreateShape(var Shape: TShape; i, j, r: ShortInt);
var c: ShortInt;
begin
With Shape do
begin
Parent:=Self;
tag:=r;
Shape:=FShapesType;
Brush.Style:=FShapesBrushStyle;
Pen.Color:=FColorShapesPen;
Pen.Width:=FWidthShapesPen;
Case FColorShapes of
colorOne:     Brush.Color:=FOneColorShapes;
colorRandom:    Brush.Color:=RGB(Random(256), Random(256), Random(256));
colorFixed2:
                begin
                c:=Abs(r);
                case c of
                1,8,15,22:  Brush.Color:=clSilver;
                2,9,16,23:  Brush.Color:=clRed;
                3,10,17,24: Brush.Color:=clLime;
                4,11,18,25: Brush.Color:=clYellow;
                5,12,19,26: Brush.Color:=clBlue;
                6,13,20,27: Brush.Color:=clFuchsia;
                7,14,21,28: Brush.Color:=claqua;
                end;
                end;
colorFixed:
                begin
                c:=Abs(r);
                case c of
                1,8,15,22:  Brush.Color:=clMaroon;
                2,9,16,23:  Brush.Color:=clGreen;
                3,10,17,24: Brush.Color:=clOlive;
                4,11,18,25: Brush.Color:=clNavy;
                5,12,19,26: Brush.Color:=clPurple;
                6,13,20,27: Brush.Color:=clTeal;
                7,14,21,28: Brush.Color:=clGray;
                end;
                end;
end;
SetBounds(wi*Pred(j)+x,he*Pred(i),wi,he);
end;
end;

procedure TTtrs.CreateShapes;
var
i1, j1, i2, j2, i3, j3, i4, j4, ij: ShortInt;
begin;
ij:=Trunc(FColumns div 2);
Case FNextShape of
 1: begin i1:=1; j1:=ij; i2:=1; j2:=Succ(ij); i3:=2; j3:=ij;       i4:=3; j4:=ij; end;
 2: begin i1:=1; j1:=ij; i2:=1; j2:=Pred(ij); i3:=2; j3:=ij;       i4:=3; j4:=ij; end;
 3: begin i1:=2; j1:=ij; i2:=2; j2:=Pred(ij); i3:=1; j3:=ij;       i4:=3; j4:=ij; end;
 4: begin i1:=2; j1:=ij; i2:=2; j2:=Succ(ij); i3:=1; j3:=Succ(ij); i4:=3; j4:=ij; end;
 5: begin i1:=2; j1:=ij; i2:=2; j2:=Pred(ij); i3:=1; j3:=Pred(ij); i4:=3; j4:=ij; end;
 6: begin i1:=2; j1:=ij; i2:=1; j2:=ij;       i3:=3; j3:=ij;       i4:=4; j4:=ij; end;
 7: begin i1:=2; j1:=ij; i2:=2; j2:=Succ(ij); i3:=1; j3:=Succ(ij); i4:=1; j4:=ij; end;
end;
if (Sh[i1,ij]<>nil) or (Sh[i2,j2]<>nil) or (Sh[i3,j3]<>nil)
or (Sh[i4,j4]<>nil) then OverT else
  begin
  Sh[i1,j1]:=TShape.Create(Self);
  Sh[i2,j2]:=TShape.Create(Self);
  Sh[i3,j3]:=TShape.Create(Self);
  Sh[i4,j4]:=TShape.Create(Self);
  CreateShape(Sh[i1,j1], i1, j1, FNextShape);
  CreateShape(Sh[i2,j2], i2, j2, -FNextShape);
  CreateShape(Sh[i3,j3], i3, j3, -FNextShape);
  CreateShape(Sh[i4,j4], i4, j4, -FNextShape);
  FNextShape:=Random(7)+1;
  SetNextShape(FNextShape);
  Contact;
  end;
end;

procedure TTtrs.Delete;
begin
if assigned(FOnDelete) then FOnDelete(Self);
end;

procedure TTtrs.Contact;
begin
if assigned(FOnContact) then FOnContact(Self);
end;

procedure TTtrs.SetColorShapes(Value: TColorTShapes);
begin
if FColorShapes<>Value then FColorShapes:=Value;
end;

procedure TTtrs.SetOneColorShapes(Value: TColor);
begin
if FOneColorShapes<>Value then FOneColorShapes:=Value;
end;

procedure TTtrs.SetColorShapesPen(Value: TColor);
begin
if FColorShapesPen<>Value then FColorShapesPen:=Value;
end;

procedure TTtrs.SetShapesType(Value: TShapeType);
begin
if FShapesType<>Value then FShapesType:=Value;
end;

procedure TTtrs.SetDelay(Value: Cardinal);
begin
if FDelay<>Value then FDelay:=Value;
Timer1.Interval:=FDelay;
end;

procedure TTtrs.SetStart(Value: Boolean);
begin
if FStart = Value then exit;
FStart:=Value;
if FStart=True then
    FNextShape:=Random(7)+1;
    FFirstFocus:=False;
    CreateShapes;
    he:=Trunc(Height div FRows);
    wi:=Trunc(Width div FColumns);
    x:=(Width-FColumns*wi) div 2;
    if Panel1<>nil then Panel1.Height:=Height-FRows*he;
end;

procedure TTtrs.SetPause(Value: Boolean);
begin
if FPause=Value then exit;
FPause:=Value;
if FPause=True then begin if Timer1<>nil then Timer1.Enabled:=False end
else if Timer1<>nil then Timer1.Enabled:=True;
end;

procedure TTtrs.SetShapesBrushStyle(Value: TBrushStyle);
begin
if FShapesBrushStyle <> Value then FShapesBrushStyle:=Value;
end;

procedure TTtrs.SetNextShape(Value: TTShape);
begin
if FNextShape<>Value then FNextShape:=Value;
if FNextSColor=False then exit;
if  (FColorShapes=ColorFixed) then
                case FNextShape of
                1: Color:=clMaroon;
                2: Color:=clGreen;
                3: Color:=clOlive;
                4: Color:=clNavy;
                5: Color:=clPurple;
                6: Color:=clTeal;
                7: Color:=clGray;
                end;
if  (FColorShapes=ColorFixed2) then
               case FNextShape of
                1: Color:=clSilver;
                2: Color:=clRed;
                3: Color:=clLime;
                4: Color:=clYellow;
                5: Color:=clBlue;
                6: Color:=clFuchsia;
                7: Color:=claqua;
                end;
end;

procedure TTtrs.SetNextSColor(Value: Boolean);
begin
if FNextSColor<>Value then
FNextSColor:=Value;
end;

procedure TTtrs.SetWidthShapesPen(Value: Integer);
begin
if FWidthShapesPen<>Value then FWidthShapesPen:=Value;
end;


procedure TTtrs.SetColorF(Value: TColor);
begin
if FColorF<>Value then
  begin
  FColorF:=Value;
  Panel1.Color:=FColorF;
  end;
end;

procedure TTtrs.SetColumns(Value: TTColumns);
begin
if FColumns<>Value then FColumns:=Value;
end;

procedure TTtrs.SetRows(Value: TTRows);
begin
if FRows<>Value then FRows:=Value;
end;

procedure TTtrs.SetTetrisKey(Value: TTSKey);
begin
if (FTetrisKey<>Value)then FTetrisKey:=Value;
Case FTetrisKey of
     Lft: Left;
     Rgh: Right;
     Drp: DropDown;
     Rtt: Rotate;
     end;
end;

procedure TTtrs.OverT;
begin
FStart:=False;
for i:=FRows downto 1 do
for j:=1 to FColumns do
if Sh[i,j]<>nil then
                    begin
                    Sh[i,j].Free;
                    Sh[i,j]:=nil;
                    end;
if assigned(FOnOverT) then FOnOverT(Self);
end;

procedure TTtrs.EndFlying;
var
k,l,n: ShortInt;
begin
Timer1.Interval:=FDelay;
for n:=1 to 4 do
for i:=FRows downto 1 do
 begin
 k:=0;
 for j:=1 to FColumns do if Sh[i,j]<>nil then k:=k+1;
 if k=FColumns then
  begin
  Delete;
  for l:=i downto 2 do
   begin
   for j:=1 to FColumns do
    begin
    Sh[l,j].Free; Sh[l,j]:=nil;
    end;
   for j:=1 to FColumns do
   if Sh[Pred(l),j]<>nil then
    begin
    Sh[l,j]:=TShape.Create(Self);
    CreateShape(Sh[l,j], l, j, 0);
    Sh[l,j].Brush.Color:=Sh[Pred(l),j].Brush.Color;
    end;
   end;
  end;
 end;
CreateShapes;
end;

procedure TTtrs.Left;
var
k,j1: ShortInt;
II,JJ: array [1..4] of Shortint;
begin
k:=0;
for i:=1 to FRows do
for j:=1 to FColumns do
if Sh[i,j]<>nil then if Sh[i,j].Tag<>0 then
    begin
    j1:=Pred(j);
    if (j=1) or ((Sh[i,j1]<>nil)and(Sh[i,j1].Tag=0)) then exit;
    Inc(k);
    II[k]:=i; JJ[k]:=j;
    if k=4 then break;
    end;
 if k=4 then
 begin
 for k:=1 to 4 do
       begin
       i:=II[k]; j:=JJ[k];
       j1:=Pred(j);
       Sh[i,j1]:=TShape.Create(Self);
       CreateShape(Sh[i,j1], i, j1, Sh[i,j].Tag);
       Sh[i,j].Free;
       Sh[i,j]:=nil;
       end;
 end;
end;

procedure TTtrs.Right;
var
k,j1: ShortInt;
II,JJ: array [1..4] of Shortint;
begin
k:=0;
for i:=1 to FRows do
for j:=FColumns downto 1 do
if Sh[i,j]<>nil then if Sh[i,j].Tag<>0 then
    begin
    j1:=Succ(j);
    if (j=FColumns) or ((Sh[i,j1]<>nil)and(Sh[i,j1].Tag=0))then exit;
    Inc(k);
    II[k]:=i; JJ[k]:=j;
    if k=4 then break;
    end;
 if k=4 then
 begin
 for k:=1 to 4 do
    begin
    i:=II[k]; j:=JJ[k];
    j1:=Succ(j);
    Sh[i,j1]:=TShape.Create(Self);
    CreateShape(Sh[i,j1], i, j1, Sh[i,j].Tag);
    Sh[i,j].Free;
    Sh[i,j]:=nil;
    end;
 end;
end;

procedure TTtrs.Rotate;
var
i1,j1,i11,j11,i2,j2,i22,j22,i18,i19,j8,j9: ShortInt;
begin
i19:=Pred(FRows); i18:=Pred(i19); j9:=Pred(FColumns); j8:=Pred(j9);
for j:=1 to FColumns do
for i:=FRows downto 1 do
if Sh[i,j]<>nil then if Sh[i,j].Tag>0 then
  begin
  j1:=Pred(j); j11:=Succ(j); j2:=Pred(j1); j22:=Succ(j11);
  i1:=Pred(i); i11:=Succ(i); i2:=Pred(i1); i22:=Succ(i11);
  if (Sh[i,j].Tag=1)and(Sh[i1,j]=nil)
  and(Sh[i,j22]=nil)and(i>1)and(j<j9)then
    begin
    Sh[i1,j]:=TShape.Create(Self);
    Sh[i,j22]:=TShape.Create(Self);
    CreateShape(Sh[i1,j],i1,j,-8);
    CreateShape(Sh[i,j22],i,j22,-8);
    Sh[i22,j].Free; Sh[i11,j].Free;
    Sh[i22,j]:=nil; Sh[i11,j]:=nil;
    Sh[i,j].Tag:=8;
    Timer1.Enabled:=True; exit;
    end;
  if (Sh[i,j].Tag=8)and(Sh[i2,j]=nil)
    and(Sh[i,j1]=nil)and(i>2)and(j>1)then
    begin
    Sh[i2,j]:=TShape.Create(Self);
    Sh[i,j1]:=TShape.Create(Self);
    CreateShape(Sh[i2,j],i2,j,-15);
    CreateShape(Sh[i,j1],i,j1,-15);
    Sh[i,j22].Free; Sh[i,j11].Free;
    Sh[i,j22]:=nil; Sh[i,j11]:=nil;
    Sh[i,j].Tag:=15;
    exit;
    end;
if (Sh[i,j].Tag=15)and(Sh[i,j-2]=nil)
    and(Sh[i11,j]=nil)and(i<FRows)and(j>2)then
    begin
    Sh[i,j2]:=TShape.Create(Self);
    Sh[i11,j]:=TShape.Create(Self);
    CreateShape(Sh[i,j2],i,j2,-22);
    CreateShape(Sh[i11,j],i11,j,-22);
    Sh[i1,j].Free; Sh[i2,j].Free;
    Sh[i1,j]:=nil; Sh[i2,j]:=nil;
    Sh[i,j].Tag:=22;
    exit;
    end;

if (Sh[i,j].Tag=22)and(Sh[i,j11]=nil)
    and(Sh[i22,j]=nil)and(j<FColumns)and(i<i19)then
    begin
    Sh[i,j11]:=TShape.Create(Self);
    Sh[i22,j]:=TShape.Create(Self);
    CreateShape(Sh[i,j11],i,j11,-1);
    CreateShape(Sh[i22,j],i22,j,-1);
    Sh[i,j1].Free; Sh[i,j2].Free;
    Sh[i,j1]:=nil; Sh[i,j2]:=nil;
    Sh[i,j].Tag:=1;
    exit;
    end;

if (Sh[i,j].Tag=2)and(Sh[i,j+1]=nil)and(Sh[i,j+2]=nil)and(j<j9)then
    begin
    Sh[i,j11]:=TShape.Create(Self);
    Sh[i,j22]:=TShape.Create(Self);
    CreateShape(Sh[i,j11],i,j11,-9);
    CreateShape(Sh[i,j22],i,j22,-9);
    Sh[i,j1].Free; Sh[i22,j].Free;
    Sh[i,j1]:=nil; Sh[i22,j]:=nil;
    Sh[i,j].Tag:=9;
    exit;
    end;

if (Sh[i,j].Tag=9)and(Sh[i-1,j]=nil)
    and(Sh[i-2,j]=nil)and(i>2)then
    begin
    Sh[i1,j]:=TShape.Create(Self);
    Sh[i2,j]:=TShape.Create(Self);
    CreateShape(Sh[i1,j],i1,j,-16);
    CreateShape(Sh[i2,j],i2,j,-16);
    Sh[i11,j].Free; Sh[i,j22].Free;
    Sh[i11,j]:=nil; Sh[i,j22]:=nil;
    Sh[i,j].Tag:=16;
    exit;
    end;

if (Sh[i,j].Tag=16)and(Sh[i,j1]=nil)
    and(Sh[i,j2]=nil)and(j>2) then
    begin
    Sh[i,j1]:=TShape.Create(Self);
    Sh[i,j2]:=TShape.Create(Self);
    CreateShape(Sh[i,j1],i,j1,-23);
    CreateShape(Sh[i,j2],i,j2,-23);
    Sh[i,j11].Free; Sh[i2,j].Free;
    Sh[i,j11]:=nil; Sh[i2,j]:=nil;
    Sh[i,j].Tag:=23;
    exit;
    end;

if (Sh[i,j].Tag=23)and(Sh[i11,j]=nil)
    and(Sh[i22,j]=nil)and(i<i19)then
    begin
    Sh[i11,j]:=TShape.Create(Self);
    Sh[i22,j]:=TShape.Create(Self);
    CreateShape(Sh[i11,j],i11,j,-2);
    CreateShape(Sh[i22,j],i22,j,-2);
    Sh[i1,j].Free; Sh[i,j2].Free;
    Sh[i1,j]:=nil; Sh[i,j2]:=nil;
    Sh[i,j].Tag:=2;
    exit;
    end;

if (Sh[i,j].Tag=3)and(Sh[i,j11]=nil)and(j<FColumns) then
    begin
    Sh[i,j11]:=TShape.Create(Self);
    CreateShape(Sh[i,j11],i,j11,-10);
    Sh[i1,j].Free;
    Sh[i1,j]:=nil;
    Sh[i,j].Tag:=10;
    exit;
    end;

if (Sh[i,j].Tag=10)and(Sh[i1,j1]=nil)and(i>1) then
    begin
    Sh[i-1,j]:=TShape.Create(Self);
    CreateShape(Sh[i1,j],i1,j,-17);
    Sh[i,j1].Free;
    Sh[i,j1]:=nil;
    Sh[i,j].Tag:=17;
    exit;
    end;

if (Sh[i,j].Tag=17)and(Sh[i,j1]=nil)and(j>1) then
    begin
    Sh[i,j1]:=TShape.Create(Self);
    CreateShape(Sh[i,j1],i,j1,-24);
    Sh[i11,j].Free;
    Sh[i11,j]:=nil;
    Sh[i,j].Tag:=24;
    exit;
    end;

if (Sh[i,j].Tag=24)and(Sh[i11,j]=nil)and(i<FRows) then
    begin
    Sh[i11,j]:=TShape.Create(Self);
    CreateShape(Sh[i11,j],i11,j,-3);
    Sh[i,j11].Free;
    Sh[i,j11]:=nil;
    Sh[i,j].Tag:=3;
    exit;
    end;

if  (Sh[i,j].Tag=4)and(Sh[i1,j1]=nil)
    and(Sh[i1,j]=nil)and(j>1)and(i>1)then
    begin
    Sh[i1,j1]:=TShape.Create(Self);
    Sh[i1,j]:=TShape.Create(Self);
    CreateShape(Sh[i1,j1],i1,j1,-11);
    CreateShape(Sh[i1,j],i1,j,-11);
    Sh[i1,j11].Free; Sh[i11,j].Free;
    Sh[i1,j11]:=nil; Sh[i11,j]:=nil;
    Sh[i,j].Tag:=11;
    exit;
    end;

if  (Sh[i,j].Tag=11)and(Sh[i,j1]=nil)
    and(Sh[i11,j1]=nil)and(i<FRows)then
    begin
    Sh[i,j1]:=TShape.Create(Self);
    Sh[i11,j1]:=TShape.Create(Self);
    CreateShape(Sh[i,j1],i,j1,-18);
    CreateShape(Sh[i11,j1],i11,j1,-18);
    Sh[i1,j1].Free; Sh[i,j11].Free;
    Sh[i1,j1]:=nil; Sh[i,j11]:=nil;
    Sh[i,j].Tag:=18;
    exit;
    end;

if  (Sh[i,j].Tag=18)and(Sh[i11,j]=nil)
    and(Sh[i11,j11]=nil)and(j<FColumns)then
    begin
    Sh[i11,j]:=TShape.Create(Self);
    Sh[i11,j11]:=TShape.Create(Self);
    CreateShape(Sh[i11,j],i11,j,-25);
    CreateShape(Sh[i11,j11],i11,j11,-25);
    Sh[i11,j1].Free; Sh[i1,j].Free;
    Sh[i11,j1]:=nil; Sh[i1,j]:=nil;
    Sh[i,j].Tag:=25;
    exit;
    end;

if  (Sh[i,j].Tag=25)and(Sh[i,j11]=nil)
    and(Sh[i1,j11]=nil)and(j<j9)then
    begin
    Sh[i,j11]:=TShape.Create(Self);
    Sh[i1,j11]:=TShape.Create(Self);
    CreateShape(Sh[i,j11],i,j11,-4);
    CreateShape(Sh[i1,j11],i1,j+1,-4);
    Sh[i,j1].Free; Sh[i11,j11].Free;
    Sh[i,j1]:=nil; Sh[i11,j11]:=nil;
    Sh[i,j].Tag:=4;
    exit;
    end;

if  (Sh[i,j].Tag=5)and(Sh[i,j11]=nil)
    and(Sh[i11,j1]=nil)and(j<FColumns)then
    begin
    Sh[i,j11]:=TShape.Create(Self);
    Sh[i11,j1]:=TShape.Create(Self);
    CreateShape(Sh[i,j11],i,j11,-12);
    CreateShape(Sh[i11,j1],i11,j1,-12);
    Sh[i,j1].Free; Sh[i1,j1].Free;
    Sh[i,j1]:=nil; Sh[i1,j1]:=nil;
    Sh[i,j].Tag:=12;
    exit;
    end;

if  (Sh[i,j].Tag=12)and(Sh[i1,j]=nil)
    and(Sh[i11,j11]=nil)and(i>1)then
    begin
    Sh[i1,j]:=TShape.Create(Self);
    Sh[i11,j11]:=TShape.Create(Self);
    CreateShape(Sh[i1,j],i1,j,-19);
    CreateShape(Sh[i11,j11],i11,j11,-19);
    Sh[i11,j1].Free; Sh[i11,j].Free;
    Sh[i11,j1]:=nil; Sh[i11,j]:=nil;
    Sh[i,j].Tag:=19;
    exit;
    end;

if  (Sh[i,j].Tag=19)and(Sh[i1,j11]=nil)
    and(Sh[i,j1]=nil)and(i>1)then
    begin
    Sh[i1,j11]:=TShape.Create(Self);
    Sh[i,j1]:=TShape.Create(Self);
    CreateShape(Sh[i1,j11],i1,j11,-26);
    CreateShape(Sh[i,j1],i,j1,-26);
    Sh[i,j11].Free; Sh[i11,j11].Free;
    Sh[i,j11]:=nil; Sh[i11,j11]:=nil;
    Sh[i,j].Tag:=26;
    exit;
    end;

if  (Sh[i,j].Tag=26)and(Sh[i11,j]=nil)
    and(Sh[i1,j1]=nil)and(i<FRows)then
    begin
    Sh[i11,j]:=TShape.Create(Self);
    Sh[i1,j1]:=TShape.Create(Self);
    CreateShape(Sh[i11,j],i11,j,-5);
    CreateShape(Sh[i1,j1],i1,j1,-5);
    Sh[i1,j].Free; Sh[i1,j11].Free;
    Sh[i1,j]:=nil; Sh[i1,j11]:=nil;
    Sh[i,j].Tag:=5;
    exit;
    end;

if  (Sh[i,j].Tag=6)and(Sh[i,j1]=nil)
    and(Sh[i,j11]=nil)and(Sh[i,j22]=nil)and(j in [2..j8])then
    begin
    Sh[i,j1]:=TShape.Create(Self);
    Sh[i,j11]:=TShape.Create(Self);
    Sh[i,j22]:=TShape.Create(Self);
    CreateShape(Sh[i,j1],i,j1,-13);
    CreateShape(Sh[i,j11],i,j11,-13);
    CreateShape(Sh[i,j22],i,j22,-13);
    Sh[i1,j].Free; Sh[i11,j].Free;  Sh[i22,j].Free;
    Sh[i1,j]:=nil; Sh[i11,j]:=nil;  Sh[i22,j]:=nil;
    Sh[i,j].Tag:=13;
    exit;
    end;

if  (Sh[i,j].Tag=13)and(Sh[i2,j]=nil)
    and(Sh[i1,j]=nil)and(Sh[i11,j]=nil)and(i in [3..i19])then
    begin
    Sh[i2,j]:=TShape.Create(Self);
    Sh[i1,j]:=TShape.Create(Self);
    Sh[i11,j]:=TShape.Create(Self);
    CreateShape(Sh[i2,j],i2,j,-20);
    CreateShape(Sh[i1,j],i1,j,-20);
    CreateShape(Sh[i11,j],i11,j,-20);
    Sh[i,j1].Free; Sh[i,j11].Free;  Sh[i,j22].Free;
    Sh[i,j1]:=nil; Sh[i,j11]:=nil;  Sh[i,j22]:=nil;
    Sh[i,j].Tag:=20;
    exit;
    end;

if  (Sh[i,j].Tag=20)and(Sh[i,j2]=nil)
    and(Sh[i,j1]=nil)and(Sh[i,j11]=nil)and(j in [3..j9])then
    begin
    Sh[i,j2]:=TShape.Create(Self);
    Sh[i,j1]:=TShape.Create(Self);
    Sh[i,j11]:=TShape.Create(Self);
    CreateShape(Sh[i,j2],i,j2,-27);
    CreateShape(Sh[i,j1],i,j1,-27);
    CreateShape(Sh[i,j11],i,j11,-27);
    Sh[i2,j].Free; Sh[i1,j].Free;  Sh[i11,j].Free;
    Sh[i2,j]:=nil; Sh[i1,j]:=nil;  Sh[i11,j]:=nil;
    Sh[i,j].Tag:=27;
    exit;
    end;

if  (Sh[i,j].Tag=27)and(Sh[i1,j]=nil)
    and(Sh[i11,j]=nil)and(Sh[i22,j]=nil)and(i in [2..i18])then
    begin
    Sh[i1,j]:=TShape.Create(Self);
    Sh[i11,j]:=TShape.Create(Self);
    Sh[i22,j]:=TShape.Create(Self);
    CreateShape(Sh[i1,j],i1,j,-6);
    CreateShape(Sh[i11,j],i11,j,-6);
    CreateShape(Sh[i22,j],i22,j,-6);
    Sh[i,j2].Free; Sh[i,j1].Free;  Sh[i,j11].Free;
    Sh[i,j2]:=nil; Sh[i,j1]:=nil;  Sh[i,j11]:=nil;
    Sh[i,j].Tag:=6;
    exit;
    end;
end;
end;

procedure TTtrs.DropDown;
begin
Timer1.Interval:=20;
end;

procedure TTtrs.TetrisKeyDown(var Key: Word; Shift: TShiftState);
begin
if FPause=True then exit;
 Case Key of
 VK_NumPad2: DropDown;
 VK_NumPad4: Left;
 VK_NumPad5: Rotate;
 VK_NumPad6: Right;
 end;
end;

procedure TTtrs.Paint;
begin
inherited Paint;
if not FFirstFocus then begin SetFocus; FFirstFocus:=True; end;
end;

procedure TTtrs.Resize;
begin
inherited Resize;
if FStart=False then begin Panel1.Height:=0; exit; end;
he:=Trunc(Height div FRows);
wi:=Trunc(Width div FColumns);
x:=(Width-FColumns*wi) div 2;
 for i:=1 to FRows do
 for j:=1 to FColumns do
 if Sh[i,j]<>nil then Sh[i,j].SetBounds(wi*Pred(j)+x,he*Pred(i),wi,he);
Panel1.Height:=Height-FRows*he;
end;

procedure TTtrs.WMNCHitTest(var Mes: TWMNCHitTest);
begin
inherited;
  if Mes.Result=htClient
  then Mes.Result:=htCaption;
SetFocus;
end;

                          { TTransPan  }

constructor TTransPan.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
FSRowsColumns:=4;
FTRows:=20;
FTColumns:=10;
FState:=StPanel;
FStartT:=False;
FStartS:=False;
FPauseT:=False;
FPauseS:=False;
FTime:=0.0;
FLines:=0;
FTScores:=0;
FNextTShape:=7;
FAbout := ' Alexander Gogava 1998';
FColorSB:=clBtnFace;
FColorTB:=clBtnFace;
FColorTF:=clBlack;
FColorTShapes:=colorFixed;
FOneColorTShapes:=clBlack;
FColorTShapesPen:=clWhite;
FDelayT:=200;
FNextSColorT:=False;
FShapesTType:=stRoundRect;
FShapesTBrushStyle:=bsSolid;
FShowTScores:=True;
FShowSTime:=True;
FTCoeff:=1;
FWidthTShapesPen:=1;
FSCaption:='';
FTCaption:='';
FWithCaption:=True;
Scrmbl1:=nil;
Ttrs1:=nil;
end;

Destructor TTransPan.Destroy;
begin
if Ttrs1<>nil then Ttrs1.Free;
if Scrmbl1<>nil then Scrmbl1.Free;
inherited Destroy;
end;

procedure TTransPan.ChangeParams;
begin
FStyle:=GetWindowLong(Handle,GWL_STYLE);
if FWithCaption then FStyle:=(FStyle xor WS_Caption xor WS_THICKFRAME)
 else
 FStyle:=(FStyle xor WS_THICKFRAME);
 SetWindowLong(Handle, GWL_STYLE, FStyle);
 if FState=StPanel then
 SetWindowPos(Handle, HWND_TOP, fx, fy, fcx, fcy, SWP_DRAWFRAME)
else
 begin
 fx:=Left; fy:=Top; fcx:=Width; fcy:=Height;
 SetWindowPos(Handle, HWND_TOP, 0, 0, 0, 0,
 SWP_NOMOVE or SWP_NOSIZE or SWP_NOZORDER or SWP_DRAWFRAME
 or SWP_NOACTIVATE);
end;
end;

procedure TTransPan.TetrisOver(Sender: TObject);
begin
TTrs1.Caption:=FTCaption; FStartT:=False;
if assigned(FOnTetrisOver) then FOnTetrisOver(Self);
end;

procedure TTransPan.TetrisSet;
begin
if assigned(FOnTetrisSet) then FOnTetrisSet(Self);
end;

procedure TTransPan.TetrisContact(Sender: TObject);
begin
FNextTShape:=TTrs1.NextShape;
if assigned(FOnTetrisContact) then FOnTetrisContact(Self);
end;

procedure TTransPan.TetrisDeleteLine(Sender: TObject);
begin
FLines:=FLines+1;
FTScores:=FLines*FTCoeff;
 Case ShowTScores of
 True: Caption:=' Scores: '+IntToStr(FTScores);
 False:     Caption:='';
 end;
if assigned(FOnTetrisDeleteLine) then FOnTetrisDeleteLine(Self);
end;

procedure TTransPan.ScrambleOver(Sender: TObject);
begin
Scrmbl1.Start:=False;
Scrmbl1.Caption:=FSCaption;
FStartS:=False;
if assigned(FOnScrambleOver) then FOnScrambleOver(Self);
end;

procedure TTransPan.ScrambleTime;
var
Tmp: String;
begin
FTime:=FTime+0.1;
if assigned(FOnScrambleTime) then FOnScrambleTime(Self);
if FShowSTime=False then begin Caption:=''; exit; end;
Str(Time:10:1,Tmp);
Caption:=' Time:'+Tmp+' sec';
end;

procedure TTransPan.TransPanKeyDown
(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
inherited KeyDown(Key,Shift);
 Case State of
 Tetris:   if Ttrs1<>nil then if (TTrs1.Start) and (not Ttrs1.Pause)then
           Ttrs1.TetrisKeyDown(key,Shift);
 Scramble: if Scrmbl1<>nil then if (Scrmbl1.Start) and (not Scrmbl1.Pause)then
           Scrmbl1.ScrambleKeyDown(key,Shift);
 end;
PanelSetFocus;
end;

procedure TTransPan.ChangeState;
begin
if FState=StPanel then
begin
      if Scrmbl1<>nil then
      begin
      Scrmbl1.Free;
      Scrmbl1:=nil;
      ChangeParams;
      Caption:=temp;
      FStartS:=False;
      FPauseS:=False;
      end
      else if TTrs1<>nil then
      begin
      Ttrs1.Free;
      Ttrs1:=nil;
      ChangeParams;
      Caption:=temp;
      FStartT:=False;
      FPauseT:=False;
      end;
 end
else
 if State=Tetris then
 begin
 if Scrmbl1<>nil then
                 begin
                 Scrmbl1.Free;
                 Scrmbl1:=nil;
                 Caption:=temp;
                 FStartS:=False;
                 FPauseS:=False;
                 end
                 else ChangeParams;
 temp:=Caption;
 Caption:='PLEASE WAIT';
 Ttrs1:=TTtrs.Create(Self);
     With Ttrs1 do
     begin
     Start:=False;
     Columns:=FTColumns;
     Rows:=FTRows;
     Align:=AlClient;
     Pause:=False;
     Caption:='';
     Color:=FColorTB;
     ColorF:=FColorTF;
     ColorShapes:=FColorTShapes;
     ColorShapesPen:=FColorTShapesPen;
     NextSColor:=FNextSColorT;
     NextShape:=FNextTShape;
     ShapesBrushStyle:=FShapesTBrushStyle;
     WidthShapesPen:=FWidthTShapesPen;
     OneColorShapes:=FOneColorTShapes;
     Delay:=FDelayT;
     ShapesType:=FShapesTType;
     OnKeyDown:=TransPanKeyDown;
     OnDelete:=TetrisDeleteLine;
     OnOverT:=TetrisOver;
     OnContact:=TetrisContact;
     TabStop:=True;
     Parent:=Self;
     end;
 FLines:=0;
              Case ShowTScores of
              True:    Caption:=' Scores:  0';
              False:     Caption:='';
              end;
 end;
 if State=Scramble then
 begin
 if Ttrs1<>nil then
                 begin
                 Ttrs1.Free;
                 Ttrs1:=nil;
                 Caption:=temp;
                 FStartT:=False;
                 FPauseT:=False;
                 end
                 else ChangeParams;
 temp:=Caption;
 Caption:='PLEASE WAIT';
 Scrmbl1:=TScrmbl.Create(Self);
     With Scrmbl1 do
     begin
     Start:=false;
     RowsColumns:=FSRowsColumns;
     Align:=AlClient;
     Caption:='';
     Color:=FColorSB;
     Pause:=False;
     OnKeyDown:=TransPanKeyDown;
     OnTime:=ScrambleTime;
     OnOverS:=ScrambleOver;
     TabStop:=True;
     Parent:=Self;
     end;
     FTime:=0.;
 if FShowSTime=True then
 Caption:='Time:  0  sec.' else Caption:='';
 end;
end;

procedure TTransPan.SetShowSTime(Value: Boolean);
begin
try
if FShowSTime<>Value then FShowSTime :=Value;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetTCoeff(Value: Integer);
begin
try
if FTCoeff<>Value then FTCoeff:=Value;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetTKey(Value: TTSKey);
begin
try
if (State=Tetris) and (Ttrs1<>nil) and (Value in [Lft..Rtt]) then
begin
if (FTKey<>Value)then FTKey:=Value;
if FStartT then if not FPauseT then TTrs1.TetrisKey:=FTKey;
end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetSKey(Value: TTSKey);
begin
try
if (State=Scramble) and (Scrmbl1<>nil) and (not(Value in [Drp..Rtt]))then
begin
if (FSKey<>Value)then FSKey:=Value;
if FStartS then if not FPauseS then Scrmbl1.ScrambleKey:=FSKey;
end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetShowTScores(Value: Boolean);
begin
try
if FShowTScores<>Value then FShowTScores:=Value;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetState(Value: TState);
begin
if FState<>Value then
  begin
  try
  FState:=Value;
  finally
  if not (csDesigning in ComponentState) then ChangeState;
  end;
  end;
end;

procedure TTransPan.SetStartT(Value: Boolean);
begin
if (csDesigning in ComponentState)then FStartT:=Value
else
if FState=Tetris then if TTrs1<>nil then
if FStartT<>Value then
  if FStartT=False then
  begin
  FStartT:=Value;
  FTScores:=0; FLines:=0;
  Ttrs1.Caption:='';
  FLines:=0;
  Case ShowTScores of
  True:    Caption:=' Scores: 0';
  False:     Caption:='';
  end;
  Ttrs1.Start:=True;
  end;
end;

procedure TTransPan.SetStartS(Value: Boolean);
begin
if (csDesigning in ComponentState)then FStartS:=Value
else
if FState=Scramble then if Scrmbl1<>nil then
if FStartS<>Value then
if FStartS=False then
  begin
  FStartS:=Value;
  FTime:=0.;
  if FShowSTime=True then
  Caption:='Time:  0  sec.' else Caption:='';
  Scrmbl1.Caption:='';
  Scrmbl1.Start:=True;
  end;
end;

procedure TTransPan.SetPauseT(Value: Boolean);
begin
try
if (csDesigning in ComponentState)then exit;
if FState=Tetris then
if FPauseT<>Value then
  begin
  if FStartT=False then begin PanelSetFocus; Exit; end;
  FPauseT:=Value;
  Ttrs1.Pause:=Value;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetPauseS(Value: Boolean);
begin
try
if (csDesigning in ComponentState)then exit;
if FState=Scramble then
if FPauseS<>Value then
  begin
  if FStartS=False then begin PanelSetFocus; Exit; end;
  FPauseS:=Value;
  Scrmbl1.Pause:=Value;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetColorTF(Value: TColor);
begin
try
if FColorTF<>Value then
  begin
  FColorTF:=Value;
  if State=Tetris then if Ttrs1<>nil then Ttrs1.ColorF:=FColorTF;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetDelayT(Value: Cardinal);
begin
try
  if FDelayT<>Value then FDelayT:=Value;
  if State=Tetris then if Ttrs1<>nil then TTrs1.Delay:=FDelayT;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetColorTShapes(Value: TColorTShapes);
begin
try
if FColorTShapes<>Value then
  begin
  FColorTShapes:=Value;
  if State=Tetris then if Ttrs1<>nil then
  Ttrs1.ColorShapes:=FColorTShapes;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetWithCaption(Value: Boolean);
begin
try
if (not (csDesigning in ComponentState))and (State<>stPanel)then
 begin PanelSetFocus; exit; end
 else
 if FWithCaption<>Value then
 FWithCaption:=Value;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetOneColorTShapes(Value: TColor);
begin
try
if FOneColorTShapes<>Value then
   begin
   FOneColorTShapes:=Value;
   if State=Tetris then if Ttrs1<>nil then
   Ttrs1.OneColorShapes:=FOneColorTShapes;
   end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetColorTShapesPen(Value: TColor);
begin
try
if FColorTShapesPen<>Value then
  begin
  FColorTShapesPen:=Value;
  if State=Tetris then if Ttrs1<>nil then
  Ttrs1.ColorShapesPen:=FColorTShapesPen;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetWidthTShapesPen(Value: Integer);
begin
try
if FWidthTShapesPen<>Value then
  begin
  FWidthTShapesPen:=Value;
  if State=Tetris then if Ttrs1<>nil then
  Ttrs1.WidthShapesPen:=FWidthTShapesPen;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetColorTB(Value: TColor);
begin
try
if FColorTB<>Value then
  begin
  FColorTB:=Value;
  if State=Tetris then if Ttrs1<>nil then Ttrs1.Color:=FColorTB;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetColorSB(Value: TColor);
begin
try
if FColorSB<>Value then
  begin
  FColorSB:=Value;
  if State=Scramble then if Scrmbl1<>nil then Scrmbl1.Color:=FColorSB;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetNextSColorT(Value: Boolean);
begin
try
  if FNextSColorT<>Value then
  begin
  FNextSColorT:=Value;
  if State=Tetris then if Ttrs1<>nil then Ttrs1.NextSColor:=FNextSColorT;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetNextTShape(Value: TTShape);
begin
try
  if FNextTShape<>Value then
  begin
  FNextTShape:=Value;
  if State=Tetris then if Ttrs1<>nil then
  begin Ttrs1.NextShape:=FNextTShape; TetrisSet; end;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetShapesTType(Value: TShapeType);
begin
try
if FShapesTType<>Value then
  begin
  FShapesTType:=Value;
  if State=Tetris then if TTrs1<>nil then Ttrs1.ShapesType:=FShapesTType;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetShapesTBrushStyle(Value: TBrushStyle);
begin
try
if FShapesTBrushStyle<>Value then
  begin
  FShapesTBrushStyle:=Value;
  if State=Tetris then if TTrs1<>nil then
  Ttrs1.ShapesBrushStyle:=FShapesTBrushStyle;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetTCaption(Value: String);
begin
try
if FTCaption<>Value then
  begin
  FTCaption:=Value;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetSCaption(Value: String);
begin
try
if FSCaption<>Value then
  begin
  FSCaption:=Value;
  end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetTRows(Value: TTRows);
begin
try
if FTRows<>Value then
   begin
   FTRows:=Value;
   if State=Tetris then if Ttrs1<>nil then if not Ttrs1.Start
   then Ttrs1.Rows:=FTRows;
   end;
finally
   PanelSetFocus;
end;
end;

procedure TTransPan.SetTColumns(Value: TTColumns);
begin
try
if FTColumns<>Value then
   begin
   FTColumns:=Value;
   if State=Tetris then if Ttrs1<>nil then if not Ttrs1.Start
   then Ttrs1.Columns:=FTColumns;
   end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.SetSRowsColumns(Value: TSRowsColumns);
begin
try
if FSRowsColumns<>Value then begin FSRowsColumns:=Value;
if State=Scramble then if Scrmbl1<>nil then if not Scrmbl1.Start
then Scrmbl1.RowsColumns:=FSRowsColumns;
end;
finally
PanelSetFocus;
end;
end;

procedure TTransPan.PanelSetFocus;
begin
Case State of
Scramble: if Scrmbl1<>nil then if Scrmbl1.FirstFocus then Scrmbl1.SetFocus;
Tetris: if Ttrs1<>nil then if Ttrs1.FirstFocus then TTrs1.SetFocus;
end;
end;

end.





